DAT programName byte "Led3BytePasm130109a0612a", 0
CON
{{
  ******* Public Notes *******
  
  This program assumes the LEDs are connections to the shift registers
  are grouped by color while the color information in the buffer alternates
  by colors.
   
}}
{
  ******* Private Notes *******
  120808a Change to use six shift registers. Controls 16 RGB LEDs.
  121104a Add ability to read in the pins.
  06b Abandon overall dimming ability.
  09a Remove ablitity to change resolution (for now).
  09a Hard code resolution and delays.
  121111c Kind of works but too much flicker.
  11e Changed columns variable which made for strange
  colors.
  11g Fixed and/add problem but still has problems.
  11j Working with 5-bit resolution each color.
  11k Try 6-bit each color. Works well.
  11l Try 7-bits. Works but noticable flicker.
  26a Start changing to read color information from an array
  of longs. Have each color use a separate shift register.
  26c Doesn't work. None of the LEDs lit up.
  Led3BytePasm121227a revert to LedShiftRegisters121111j.
  27c Seems to scroll text on one display okay.
  130109a Add more arrays to display.
  130109a0608a Clean up code. Code has been adapted to use with
  two daisy chainged RGB LED arrays.
  09c Made resolution changable by changing constant. Also make number of
  arrays changable by changing constant "ARRAYS_USED"
  10a Resolution change is working but not I still can't change the number
  of active arrays. Only when "activeArrays" equals two do the arrays display
  correctly.
  10a The problem with changing the number of active arrays was in the parent object.
  The buffer size and row size variables weren't being changed correctly.
  10a This driver can both change the resolution and number of arrays on the fly.
  These changes require the drive cog to restart since the PASM control loop doesn't
  pause to read a command from hub. I suppose it wouldn't hurt the timing to
  read a command from hub since each loop already reads over 12 million times from the
  hub when using two arrays and 5-bit color.
  12a No long poke data into PASM code.
  12a Works.
  12b Attempt to change number of active arrays and resolution without restarting
  cog.
  12b Doesn't work.
  
} 
CON

  BIG_LOOP_OVERHEAD = 20
  SMALLER_LOOP_TIME = 48
  MAX_RESOLUTION = 256          ' since brightness is stored in a byte arrays
  PSEUDOREAL_SCALER = 1000
  MIN_PASM_WAITCNT = 10
  BITS_OF_RESOLUTION = 5
  MAX_BITS_OF_RESOLUTION = 8
  MIN_BITS_OF_RESOLUTION = 1
  RESOLUTON_REDUCER = MAX_BITS_OF_RESOLUTION - BITS_OF_RESOLUTION
  COLUMNS_PER_ARRAY = 24
  ANODE_PINS = 8
  ARRAYS_USED = 2
  ARRAY_SIZE = ANODE_PINS * COLUMNS_PER_ARRAY * ARRAYS_USED ' 384
  
  ' priorityFlag enumeration
  #0, RESOLUTION_PRIORITY, FREQUENCY_PRIORITY

  ' restart enumeration
  #0, NO_RESTART, YES_RESTART

  #0, NO_COMMAND, RESOLUTION_COMMAND, ARRAY_NUMBER_COMMAND
  
VAR

  long cog
  long commandHub, commandData[5] 'clockPinTemp, latchPinTemp, dataPinTemp, bufferAddressHub
  'long bufferSizeTemp
   
PUB Start(anodePin, clockPin, latchPin, dataPin, bufferPtr) '| tempPeriod, tempPeriod1, tempRes, tempFreq, tempFreq1
'' bufferPtr is the address with byte array to be used to control the
'' brightness of the LED array. 

  commandHub := @anodePin
  
  {clockPinTemp := clockPin
  latchPinTemp := latchPin
  dataPinTemp := dataPin
  bufferAddressHub := bufferPtr
  'bufferSizeTemp := bufferSize
  
  lastAnodeMask := 1 << (anodePin + ANODE_PINS - 1) 
  bufferAddressCog := bufferPtr 
  dataMask := 1 << dataPin
  latchMask := 1 << 15
  clockMask := 1 << 27  
  resolutionCog := (1 << BITS_OF_RESOLUTION) - 1 }
 
  'result := CheckIfRestart(YES_RESTART)
  Stop
    
  result := cog := cognew(@enter, @commandHub) + 1 
  repeat while commandHub
  longmove(@commandData, @anodePin, 5)
    
PUB Stop
'' Stop driver and release cog

  if cog
    cogstop(cog~ - 1)

PUB ChangeSize(activeArrays, restartFlag)

  totalColumns := activeArrays * COLUMNS_PER_ARRAY
  arraySize := totalColumns * ANODE_PINS
  
  result := CheckIfRestart(restartFlag)
  
PUB BitsOfResolution(newResolution, restartFlag)

  newResolution <#= MAX_BITS_OF_RESOLUTION
  resolutionReducer := MAX_BITS_OF_RESOLUTION - newResolution
  resolutionCog := (1 << newResolution) - 1
  result := CheckIfRestart(restartFlag)
 
PRI CheckIfRestart(restartFlag) 
  
  if restartFlag
    Stop
    commandHub := @commandData
    result := cog := cognew(@enter, @commandHub) + 1 
    repeat while commandHub

PUB GetProgramName

  result := @programName
             
DAT                     org
enter                   'mov     dataAddress, par         ' copy hub address of parameters
                                                        ' commandHub
                        'add     dataAddress, #4               
                        rdlong  dataAddress, par           
                        rdlong  temp1, dataAddress
                        mov     lastAnodeMask, #1
                        shl     lastAnodeMask, temp1
                        shl     lastAnodeMask, #(ANODE_PINS - 1)
                        add     dataAddress, #4         
                        rdlong  temp1, dataAddress
                        mov     clockMask, #1
                        shl     clockMask, temp1
                        add     dataAddress, #4         
                        rdlong  temp1, dataAddress
                        mov     latchMask, #1
                        shl     latchMask, temp1
                        add     dataAddress, #4         
                        rdlong  temp1, dataAddress
                        mov     dataMask, #1
                        shl     dataMask, temp1
                        add     dataAddress, #4         
                        rdlong  bufferAddressCog, dataAddress
                        mov     dataAddress, par
                        add     dataAddress, #4         
                        
                        {
                        mov     clockMask, #1
                        shl     clockMask, temp2
                        add     temp1, #4
                        rdlong  temp2, temp1            ' latchPinTemp
                        mov     latchMask, #1
                        shl     latchMask, temp2
                        add     temp1, #4
                        rdlong  temp2, temp1            ' dataPinTemp  
                        mov     dataMask, #1
                        shl     dataMask, temp2
                        add     temp1, #4               ' location of bufferAddressHub
                        mov     bufferAddressPtr, temp1
                        add     temp1, #4
                        rdlong  arraySize, temp1        ' bufferSizeTemp      
                        add     temp1, #4
                        rdlong  resolutionCog, temp1    ' resolutionHub
                        add     temp1, #4
                        rdlong  loopDelayCog, temp1     ' addedWaitEachLoop
                              
                        'sub     resolutionCog, #1       ' since zero is included
                        
                        tjnz    loopDelayCog, #addDelayToLoop
                        mov     jumpDestination, #bigLoop     }
                             
setPins                 or      dira, clockMask
                        or      dira, latchMask 
                        or      dira, dataMask
                        mov     previousAnodeMask, lastAnodeMask
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask
                        shr     previousAnodeMask, #1
                        or      dira, previousAnodeMask

                        mov     column0, initColumn0
                        mov     column1, initColumn1
                        mov     column2, initColumn2
                        wrlong  zero, par
                 
                        wrlong  zero, par   
              
newCycle                mov     periodCount, resolutionCog

bigLoop                 mov     countdown, arraySize    ' 
                        mov     tempAddr, bufferAddressCog
                        
                        mov     columnCount, #0
                        mov     tempAnodeMask, lastAnodeMask
                                                        ' smallerLoop time start
smallerLoop             rdbyte  value, tempAddr
                       
                        shr     value, resolutionReducer
                                                        
                                                       
                        add     value, #1               
                                                          
                        cmp     periodCount, value wc   
                                                       
                                                       
                                                       
          
                        muxc    outa, dataMask         
                        or      outa, clockMask

                        add     tempAddr, #3            ' jump to next memory with the same color

                   

                        add     columnCount, #1
                        andn    outa, clockMask

checkColumn0            cmp     columnCount, column0 wz
              if_z      sub     tempAddr, #23          ' jump back in memory to read next color (green) 
checkColumn1            cmp     columnCount, column1 wz
              if_z      sub     tempAddr, #23          ' jump back in memory to read next color (blue)  
checkColumn2            cmp     columnCount, column2 wz
              if_z      call     #advanceArray         
                     
                        djnz    countdown, #smallerLoop 
              
                        
                        djnz    periodCount, #bigLoop
                        
                        jmp     #newCycle 

'-------------------------------------------------------------------------------
'
advanceRow              mov     columnCount, #0
                        or      outa, latchMask 
                        andn    outa, previousAnodeMask 
                        andn    outa, latchMask
                        or      outa, tempAnodeMask
                        mov     previousAnodeMask, tempAnodeMask 
                        shr     tempAnodeMask, #1
                        mov     column0, initColumn0
                        mov     column1, initColumn1
                        mov     column2, initColumn2
advanceRow_ret          ret            
'-------------------------------------------------------------------------------

advanceArray            sub     tempAddr, #2
                        
                        cmp     columnCount, totalColumns wz
              if_z      call    #advanceRow
              if_nz     call    #continueRow
                                                
advanceArray_ret        ret            
'-------------------------------------------------------------------------------

continueRow             add     column0, #24
                        add     column1, #24
                        add     column2, #24
                        
continueRow_ret         ret            
                        

zero                    long 0
resolutionCog           long (1 << BITS_OF_RESOLUTION) - 1
'bufferAddressCog1       long 0
'bufferAddressCog2       long 0
arraySize               long ARRAY_SIZE
'bufferAddressPtr        long 0
'rows                    long 8
'rowCount                long 0
' ** This is just asking to wrapped up in a loop.
initColumn0             long 8  ' first set of red data done
initColumn1             long 16 ' first set of green data done
initColumn2             long 24 ' first set of blue data done
totalColumns            long ARRAYS_USED * 24
resolutionReducer       long RESOLUTON_REDUCER
dataMask                res 1
latchMask               res 1
clockMask               res 1
lastAnodeMask           res 1
tempAnodeMask           res 1
previousAnodeMask       res 1
bufferAddressCog        res 1
column0                 res 1
column1                 res 1
column2                 res 1
value                   res 1
tempAddr                res 1
'tempAddr1               long 0
'tempAddr2               long 0
countdown               res 1
periodCount             res 1
'cogCommand              res 1
temp1                   res 1
'temp2                   res 1

'jumpDestination         long 0
offTime                 res 1

columnCount             res 1
dataAddress             res 1
                        fit

DAT ' License

{{

 ------------------------------------------------------------------------------------------------------------------------------
|                                                   TERMS OF USE: MIT License                                                  |                                                            
 ------------------------------------------------------------------------------------------------------------------------------
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    | 
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
 ------------------------------------------------------------------------------------------------------------------------------

}}