DAT programName byte "Led3ByteColor130619a", 0 ' This will let me know what program is loaded in the Prop.
CON
{{
  ******* Public Notes *******

  Written By: Duane Degn
  Initial Release: June 2013
  MIT License (Use anyway you want but give me credit.)
  
  This is a program to light RGB LEDs using '595 shift registers.   
  Make sure and use current limiting resistors on your LEDs.
  

}}
{
  ******* Private Notes *******
  Led8by8Demo121110a start work
  on 8x8 RGB LED array.
  Use H-bridge chips on anodes and high power shift registers on cathodes.
  10d Start adding RGB support to font generation.
  10g works at displaying a pattern.
  10g Doesn't turn on the bottom row as long as the other rows which causes
  the bottom row to be dim compared with other rows.
  11b Fixed dim row.
  11e I think the PWM rate is much too slow.
  11f Try to make PASM version of PWM code.
  11g Kind of works with 11c but it has a very noticable flicker.
  11h Getting better. Reduced resolution to 16 which got rid of the
  flicker. Solid colors are not solid. Orange causes red and yellow
  stripes.
  11l Works much better but only 64-bit color.
  11m Try to increase resolution. Using 125 bit resolution still looks good.
  Works with 11j.
  11m Tried with 5, 6 and 7 bits each color. 7 bits had too much flicker.
  Propbably stay with 5 bits per color.
  11n Add menu back.
  12b Text kind of scrolls but only in red and it looks like each pixel
  is three LEDs wide.
  12e still has problems with scrolling text.
  12f Text scrolling works.
  26a Switch to longs to store colors. Each color is controlled by its own
  shift register. Use code from G-35 xmas lights and WS2801 control.
  26c Didn't work. None of the LEDs lit.
  Led3ByteColor121227a revert to Led8by8Demo121116a.
  27a No changes.
  27b Change child object.
  27c Flip font upside-down.
  27c Seems to scroll okay on a single display.
  29c Seems to work with SimplyTronics display. The scrolling isn't
  quite right with the ST display yet.
  29e The scrolling looks a lot better with the ST unit. I still
  don't know how to display two characters at once on the display.
  29e Added brightness control to larger display. Also added
  "Free Design" font to ST display.
  29e works pretty well.
  29g Characters now scroll of the end of the ST display. I still
  can't get two characters on the ST display at the same time.
  29h Two characters at once seems to be working okay on the ST
  display.
  30c Add control characters to change brightness and color from
  inside a string of characters.
  130109a Start code to add more arrays to display.
  10a Works with three Arrays.
  10c works for any number of arrays in a single row.
  If more than two arrays are used the flash from the PWM is apparent.
  11a Switch to using bits when defining resolution.
  11c Is not working correctly.
  12a With:
  ZONES_WIDE = 1 
  ZONE_WIDTH = 2
  Half of a character is displayed in the bottom half of the array.
  The portion of character displayed can be either top half or
  bottom half.
  130607a Swicth back to "Led3BytePasm130109a" driver and program
  is beginning to work. Text is displayed but the colors are wrong.
  07e Flip anodes in LED driver.
  07f Program kind of works. Rainbow text has problems.
  08a Fixed column buffer problem.
  08b Comment out a bunch of debug statements.
  08c Switch to single menu. No submenus for now.
  08d Add scroll speed control. Added pattern back as an option.
  08f Add a couple of more features.
  08g Clean up child object a bit. Still works.
  08h Save as Led3ByteColor130608hP remove most of the commented out code.
  08i Added GraphKeyboard method.
  09a Try different child object. Child object changes successful.
  09b Make changes to start to use new child object. Seems to work okay.
  09c Test with new child object. Still works.
  10a Resolution change is working but not I still can't change the number
  of active arrays. Only when "activeArrays" equals two do the arrays display
  correctly.
  10b Make changes in arrays number only affect child oject to see where problem
  lies. I think the problem is probably in this top object.
  10b Wrong way to diagnose problem. Both parent and child need to agree on
  buffer size (row size).
  10c Fixed problem with buffer size when changing number of arrays.
  10c Pattern doesn't display correctly since the pattern was designed for two
  arrays.
  10d Things are working pretty well. The pattern method still has a bug but by
  moving "messageBuffer" from after "resizedPattern" to before it, has masked the
  problem.
  I think there's a waitcnt error somewhere when transitioning from displaying
  the pattern or pulsing the arrays to text mode. There is often a longer than
  expected delay when making these transitions.
  10e Add some eye patterns.
  10f Move all eyes so they start top left of bit map. Add adjustment array.
  11a Change the way a buffer is filled with color.
  11a Works but none of the eye methods are called.
  11c "FindEyeSize" method now works correctly.
  11d Eyes kind of work. Eye modes can't be changed without leaving current eye mode.
  11d Eye positions are not correct yet.
  12b Eye mode seems to work correctly.
  12c Try different child object.
  12c Seems to work. The child object no longer pokes data into PASM code prior to launch.
  12d Try to change resolution without restarting cog.
  
} 
CON


  _CLKMODE = XTAL1 + PLL16X                             ' use crystal x 16
  _XINFREQ = 5_000_000                                  ' 5 MHz cyrstal (sys clock = 80 MHz)

  
  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000

  
  
  ' Pin Assignments
  ' Shift Registers
  SHIFT_DATA = 16
  SHIFT_CLOCK = 27 '17 '27 
  SHIFT_LATCH = 15 '18 '15         

  ' Anode Control
  FIRST_ANODE_PIN = 0           ' The seven pins after FIRST_ANODE_PIN will also be used
                                ' for anode control. 
  
  'DEFAULT_LED_FREQUENCY = 1000
  'STEPS_TO_PULSE = DEFAULT_RESOLUTION_BITS
  DATA_RESOLUTION = 256
  STACK_SIZE = 100
  BAUD = 115_200
  PSEUDO_MULTIPLIER = 1000
  'NUMBER_OF_RGB_LEDS = DISPLAY_PIXELS
  'DISPLAY_BYTES = NUMBER_OF_RGB_LEDS * 3

  DEFAULT_SHORT_PAUSE = 100
  BUFFER_DUMP_COLUMNS = 32
  TITLE_X = 3                   ' Location for title
  TITLE_Y = 1
 
  MODE_DISPLAY_X = TITLE_X '+ 11               
  MODE_DISPLAY_Y = TITLE_Y + 4
  ACTIVE_COLOR_DISPLAY_X = TITLE_X '+ 15               
  ACTIVE_COLOR_DISPLAY_Y = MODE_DISPLAY_Y + 1
  ACTIVE_LEDS_DISPLAY_X = TITLE_X '+ 14               
  ACTIVE_LEDS_DISPLAY_Y = ACTIVE_COLOR_DISPLAY_Y + 1
  ACTIVE_BRIGHTNESS_DISPLAY_X = TITLE_X '+ 20              
  ACTIVE_BRIGHTNESS_DISPLAY_Y = ACTIVE_LEDS_DISPLAY_Y + 1
  SPEED_DISPLAY_X = ACTIVE_BRIGHTNESS_DISPLAY_X
  SPEED_DISPLAY_Y = ACTIVE_BRIGHTNESS_DISPLAY_Y + 1
  RESOLUTION_DISPLAY_X = TITLE_X                
  RESOLUTION_DISPLAY_Y = SPEED_DISPLAY_Y + 1
  ACTIVE_ARRAYS_DISPLAY_X = TITLE_X                
  ACTIVE_ARRAYS_DISPLAY_Y = RESOLUTION_DISPLAY_Y + 1
  MENU_DISPLAY_X = TITLE_X                
  MENU_DISPLAY_Y = ACTIVE_ARRAYS_DISPLAY_Y + 2
  'METHOD_MESSAGE_DISPLAY_X = MENU_DISPLAY_X
  'METHOD_MESSAGE_DISPLAY_Y = MENU_DISPLAY_Y + 18
  TEMP_DISPLAY_X = TITLE_X                
  TEMP_DISPLAY_Y = MENU_DISPLAY_Y + 35
  
  BUFFER_DUMP_Y = TEMP_DISPLAY_Y
  MAX_DEBUG_Y = 50
  DEBUG_X = 80
  CLEARED_DEBUG_LINES = 5
  
  #0, FORWARD, BACKWARD

  COUNTER_CLOCKWISE = FORWARD
  CLOCKWISE = BACKWARD
  
  ' color enumeration tri color LEDs
  #0, BLACK, RED, ORANGE, YELLOW, GREEN, BLUE, VIOLET, WHITE, CYAN, INDIGO, CUSTOM_COLOR, RAINBOW

  FIRST_RAINBOW_COLOR = RED
  LAST_RAINBOW_COLOR = VIOLET

  #0, RED_PORTION, GREEN_PORTION, BLUE_PORTION

  ' LED modes  
 { #0, NAVIGATION_LEDS, CYCLON_LEDS, BOUNCING_COLORS_LEDS, WILD_LEDS, UNIFORM_RAINBOW_LEDS, {
    } VERIGATED_RAINBOW_LEDS, FLAME_LEDS, TEST_LEDS, CHASE_RED_LEDS, CHASE_GREEN_LEDS, {
    } CHASE_BLUE_LEDS, FLASH_WHITE_LEDS, BLUE_LEDS, GREEN_LEDS, RED_LEDS, WHITE_LEDS, {
    } PURPLE_LEDS, ORANGE_LEDS, YELLOW_LEDS, DYNAMIC_ALTITUDE_HOLD_LEDS, {
    } DISPLAY_ALTITUDE_LEDS, STATIC_ALTITUDE_HOLD_LEDS   }

  #0, OFF_MODE, LARSON_MODE, SOLID_MODE, DRAGON_MODE, TAIL_MODE, ROTATE_MODE, {
    } PULSE_MODE, BOW_MODE, PATTERN_MODE, CYCLE_MODE, TEXT_MODE, UPDATE_TEXT_MODE, {
    } {RAINBOW_TEXT_MODE, }WHITE_MODE, RAINBOW_ANGLED_MODE, CYCLE_TEXT_MODE, GRAPH_MODE, {
    } CHANGE_ARRAYS_MODE, CHANGE_RESOLUTION_MODE, EYES_MODE

  ' menuMode enumeration
  #0, MAIN_MENU, COLOR_MENU, NUMBER_MENU, TEXT_MENU, MESSAGE_MENU{, 
     CHOOSE_CONFIRM_MESSAGE, CHOOSE_TEXT_COLOR}

  ' ledType enumeration (only RGB LEDs are currently supported in this program)
  #1, SINGLE_COLOR, BI_COLOR, TRI_COLOR
    ' I plan to add support for monochromatic LEDs but I don't presently
    ' have plans to support BI_COLOR LEDs.

  ' activeFont enumeration
  '#0, FREE_DESIGN_FONT

  
CON

  EEPROM_FONT_ADDRESS = $8000  '' EEPROM not currently used.

  ARRAY_HEIGHT = Led#ANODE_PINS '8
  ZONES_WIDE = Led#ARRAYS_USED
  DEFAULT_ACTIVE_ARRAYS = Led#ARRAYS_USED
  ARRAYS_WIDE = ZONES_WIDE * ZONE_WIDTH
  DEFAULT_WIDTH_PIXELS = ARRAYS_WIDE * ARRAY_WIDTH_PIXELS ' 16
  DISPLAY_WIDTH_BYTES = DEFAULT_WIDTH_PIXELS * TRI_COLOR
  DISPLAY_HEIGHT = ARRAYS_HIGH * ARRAY_HEIGHT
  DEFAULT_DISPLAY_BYTES = DISPLAY_WIDTH_BYTES * DISPLAY_HEIGHT
  PATTERN_SIZE = ARRAY_WIDTH_PIXELS * TRI_COLOR * ARRAY_HEIGHT * 2
  ARRAYS_HIGH = 1            '' Do not change these constants.
  DEFAULT_RESOLUTION_BITS = Led#BITS_OF_RESOLUTION '3 ' 5
  ZONE_WIDTH = 1
  ZONES = ZONES_WIDE * ARRAYS_HIGH 
  MAX_ALLOWED_ARRAYS = 8 ' This will determine buffer sizes. If you increase this number
                         ' use "F8" to make sure you have some spare memory.
                         ' Each possible array uses 108 longs of memory.
  MIN_ALLOWED_ARRAYS = 1
  MAX_ALLOWED_WIDTH_PIXELS = ARRAY_WIDTH_PIXELS * MAX_ALLOWED_ARRAYS
  MAX_ALLOWED_BYTES_WIDTH = MAX_ALLOWED_WIDTH_PIXELS * TRI_COLOR
  MAX_ALLOWED_DISPLAY_BYTES = MAX_ALLOWED_BYTES_WIDTH * DISPLAY_HEIGHT 
  MAX_ALLOWED_PIXELS = MAX_ALLOWED_WIDTH_PIXELS  * DISPLAY_HEIGHT
 
  ' Only three arrays may be used without flicker.
  ' LED resolution maybe 16 if only two arrays are
  ' used. Three arrays with 8 resolution seems to work.
  ' Four arrays will flicker at any resolution.

  FONT_HEIGHT = 8
  FONT_WIDTH = 8
  ARRAY_WIDTH_PIXELS = 8
  DISPLAY_PIXELS = DEFAULT_WIDTH_PIXELS * DISPLAY_HEIGHT
  FONT_EEPROM_BYTE_HEIGHT = FONT_HEIGHT
  FONT_EEPROM_BYTE_WIDTH = FONT_WIDTH * TRI_COLOR
  DEFAULT_INIT_SKIP = 2
  DEFAULT_END_SKIP = 3
  DEFAULT_SPACE_BETWEEN_LETTERS = 3 '' user changable 
  DEFAULT_N_SPACING = 6 ' space between words   '' user changable 
  DEFAULT_BRIGHTNESS = 100          '' user changable but don't go higher
  DEFAULT_MAX_BRIGHTNESS = $FF              '' user changable 
  DEFAULT_MIN_BRIGHTNESS = 8 '0             '' user changable any lower wont show up 
  LARGE_BRIGHTNESS_CHANGE = 10      '' user changable 
  SMALL_BRIGHTNESS_CHANGE = 1       '' user changable 
  FONT_BYTES_PER_CHARACTER = FONT_EEPROM_BYTE_HEIGHT * FONT_EEPROM_BYTE_WIDTH 
  FONT_BYTES_IN_EEPROM = FONT_BYTES_PER_CHARACTER + 1 ' one byte to hold width of character
 
  LOWEST_ASCII_USED = 32
  HIGHEST_ASCII_USED = 126   
  '_LineLength = 12
  DEFAULT_H_SCROLL_DELAY = 100      '' user changable
  DEFAULT_SCROLL_SPEED = 80         '' user changable
  MIN_SCROLL_SPEED = 0              '' user changable
  MAX_SCROLL_SPEED = 100            '' user changable but don't go higher
  LARGE_SPEED_CHANGE = 10           '' user changable
  SMALL_SPEED_CHANGE = 1            '' user changable
  LARGEST_TEXT_MESSAGE = 140 'Pst#MAXSTR_LENGTH + 1 '160
  MAX_NUMBER_OF_MESSAGES = 256
  DEFAULT_COLOR_TRANSITIONS = 8
  DEFAULT_PRESS_PER_LED = 1
  
CON  '' this section is user changable  

  RED_R = $FF
  RED_G = 0
  RED_B = 0
  ORANGE_R = $FF
  ORANGE_G = $2F
  ORANGE_B = 0
  YELLOW_R = $FF
  YELLOW_G = $6F
  YELLOW_B = 0
  GREEN_R = 0
  GREEN_G = $FF
  GREEN_B = 0
  BLUE_R = 0
  BLUE_G = 0
  BLUE_B = $FF
  CYAN_R = 0
  CYAN_G = $FF
  CYAN_B = $FF
  INDIGO_R = $3F
  INDIGO_G = 0
  INDIGO_B = $FF
  VIOLET_R = $8F
  VIOLET_G = 0
  VIOLET_B = $FF
  WHITE_R = $FF
  WHITE_G = $CF
  WHITE_B = $3F
CON

  PIN_TX        =   23             ' used to communicate with SimplyTronics array' Connected to pin 0
  PIN_RX        =   22 

CON

  #0, FREE_DESIGN, SIMPLYTRONICS_0508', SIMPLYTRONICS_0816

  FONTS_AVAILABLE = SIMPLYTRONICS_0508 + 1 'SIMPLYTRONICS_0816 + 1

  FREE_DESIGN_WIDTH = 8
  SIMPLYTRONICS_0508_WIDTH = 8 '5
  'SIMPLYTRONICS_0816_WIDTH = 8
  FREE_DESIGN_HEIGHT = 8
  SIMPLYTRONICS_0508_HEIGHT = 8
  'SIMPLYTRONICS_0816_HEIGHT = 16
  WIDEST_POSSIBLE_FONT = 16  ' current widest is 8 but I plan to add wider fonts

  '' Control Characters
  SET_DELAY = $04
  SET_FONT = $05                ' followed by single byte
  SET_BRIGHTNESS_ST = $07       ' followed by single byte
  SET_BRIGHTNESS = $07          ' followed by single byte
  SET_FOREGROUND_COLOR = $08    ' followed by single byte
  SET_BACKGROUND_COLOR = $09    ' followed by single byte
  SET_FOREGROUND_RGB = $0B      ' followed by three bytes
  SET_BACKGROUND_RGB = $0C      ' followed by three bytes
  SD = SET_DELAY
  SF = SET_FONT
  SB = SET_BRIGHTNESS
  SBST = SET_BRIGHTNESS_ST                
  SFC = SET_FOREGROUND_COLOR 
  SBC = SET_BACKGROUND_COLOR 
  SFRGB = SET_FOREGROUND_RGB 
  SBRGB = SET_BACKGROUND_RGB
     
CON '' Eye Constants

  ' activeEye enumeration
  #0, EYE_NORMAL, EYE_SAD, EYE_SURPRISE, EYE_HAPPY, EYE_FEAR, EYE_CROSSED, {
    } EYE_OVAL_VERT, EYE_OVAL_HOR, EYE_SLIT_VERT0, EYE_SLIT_VERT1, {
    } EYE_SLIT_HOR0, EYE_SLIT_HOR1

  MAX_EYE_INDEX = EYE_SLIT_HOR1
  EYE_TYPES = MAX_EYE_INDEX + 1
  EYE_HEIGHT = 8
  EYE_WIDTH = 8
  EYES_WIDTH = EYE_WIDTH * 2
  EYES_WIDTH_BYTES = EYES_WIDTH * TRI_COLOR 
  EYE_PIXELS = EYE_HEIGHT * EYE_WIDTH
  EYE_BYTES = EYE_PIXELS * TRI_COLOR
  EYES_PIXELS = EYE_PIXELS * 2
  EYES_BYTES = EYE_BYTES * 2
                                                                                                                                                                  
VAR

  'long frequency, duration
  long ledStack[STACK_SIZE]', cycleStack[STACK_SIZE]
  'long displayPort, displayStar
  'long directionCount
  'long bufferInUsePtr, previousBufferInUsePtr
  

  long globalWait
  long globalLastTime, oneSecond, millisecond
  long debugLock', globalIndex
  long timesToFlash, flashDurationMs
  'long coloredNumber, ledNumberFlashDelay
  'long lastDisplayTime, displayDelay
  long ledCog, brightness, brightnessSt
  long activeLeds, activeLedsUpperLimit, activeLedsLowerLimit
  long shortPause, patternSize, horizontalScrollDelay
  long {globalBrightness, }eepromFontColor
  long nextFreeEepromLoc, colorTransition[TRI_COLOR]
  long globalColor[TRI_COLOR]
  long fontPtr[FONTS_AVAILABLE], stScrollIndex, pStScrollIndex
  long pactiveColorIndexL, messageLocation[MAX_NUMBER_OF_MESSAGES], messagesSavedCount 
  long incrementTimer, colorTransitions
  long pseudoColorIncrement[TRI_COLOR]
  long nextRainbowIndex, scrollSpeed
  long pressesPerLed, newPresses, spaceCount
  long eyePtr, debugY
   
  byte dayOfWeek, interuptFlag, globalChangeFlag
  byte {ledPwm[15], mainColor[3],} ledMode, previousLedMode
  'byte lastLedModeDisplayed
  'byte colorR[64], colorG[64], colorB[64], colorIndex

  'byte cycleFlag, cycleInterval
  'byte ledBuffer[DISPLAY_BYTES]
  byte tempBuffer[MAX_ALLOWED_BYTES_WIDTH + TRI_COLOR]
  'byte tempBuffer[DISPLAY_BYTES], altLedBuffer1[DISPLAY_BYTES]
  long menuMode, ledType, activeColorIndex', newLedModeFlag
  byte modifiableColorFlag, modifiableNumberFlag, modifiableBrightnessFlag
  byte displayBuffer[MAX_ALLOWED_DISPLAY_BYTES]
  byte rainbowIndex, rainbowTransitionIndex
  byte fontWidth[FONTS_AVAILABLE], fontHeight[FONTS_AVAILABLE]
  byte activeFont, activeCharacter, previousCharacter, pactiveColorIndex
  byte pActiveFont  
  byte messageSize[MAX_NUMBER_OF_MESSAGES]
  byte bufferSavedFlag, overTimeFlag
  byte columnColors[MAX_ALLOWED_BYTES_WIDTH] 'WIDEST_POSSIBLE_FONT * TRI_COLOR]
  byte nextColors[TRI_COLOR], characterColors[TRI_COLOR]
  byte tempDataFlag, previousTempDataFlag, activeEye
  
OBJ
{ RGB LED Matirx Library}                                            
  Rgb    : "RGB_LED_Matrix_Driver_Simple3.spin"    

OBJ

  Pst : "Parallax Serial Terminal"                      ' uses a cog
  Led : "Led3BytePasm130109a0612a"                       ' uses a cog
  Eeprom: "Propeller EepromDWD"
  
PUB SetUp | localIndex, localCharacter, count, colorIndex1, colorIndex2, colorIndex3
' uses a cog 3 left
      'Initialize the RC input object
  
  Pst.Start(BAUD)
  oneSecond := clkfreq
  millisecond := clkfreq / 1000
  fontWidth[FREE_DESIGN] := FREE_DESIGN_WIDTH
  fontHeight[FREE_DESIGN] := FREE_DESIGN_HEIGHT
  fontWidth[SIMPLYTRONICS_0508] := SIMPLYTRONICS_0508_WIDTH
  fontHeight[SIMPLYTRONICS_0508] := SIMPLYTRONICS_0508_HEIGHT
  'fontWidth[SIMPLYTRONICS_0816] := SIMPLYTRONICS_0816_WIDTH
  'fontHeight[SIMPLYTRONICS_0816] := SIMPLYTRONICS_0816_HEIGHT
  fontPtr[FREE_DESIGN] := @freeDesign032 
  fontPtr[SIMPLYTRONICS_0508] := @ASCII_0508_032
  'fontPtr[SIMPLYTRONICS_0816] := @ASCII_0816_032
  activeFont := FREE_DESIGN 'SIMPLYTRONICS_0508
  pActiveFont := FREE_DESIGN
  colorTransitions := DEFAULT_COLOR_TRANSITIONS
  rainbowIndex := FIRST_RAINBOW_COLOR
  nextRainbowIndex := rainbowIndex + 1
  GetColors(rainbowIndex, @characterColors)
  GetColors(nextRainbowIndex, @nextColors)
  FindIncrementalColors(@characterColors, @nextColors, @pseudoColorIncrement, colorTransitions + 1)
  'BuildLongColors
  
  'displayDelay := oneSecond / 4
  'loopInterval := clkfreq / 50
  'loopInterval -= 2 * millisecond
  'repeat result from 0 to "z" - "A"
    'messageBuffer0[result] := result + "A"
    'messageBuffer0[result * 2] := result + "A"
    'messageBuffer0[(result * 2) + 1] := 32
    'messageBuffer0[(result * 3) + 2] := 32
    
  debugLock := locknew                                  ' used for debug output, not input
  timesToFlash := 8
  flashDurationMs := 250
  brightness := DEFAULT_MAX_BRIGHTNESS
  brightnessSt := DEFAULT_MAX_BRIGHTNESS
  ledType := TRI_COLOR
  modifiableColorFlag := 1
  modifiableNumberFlag := 1
  activeLedsUpperLimit := DISPLAY_PIXELS 
  activeLedsLowerLimit := 0
  modifiableBrightnessFlag := 1
  ledMode := TEXT_MODE 'OFF_MODE 'SOLID_MODE
  menuMode := MAIN_MENU
  
  activeColorIndex := RAINBOW 'RED
  activeLeds := 5 'DISPLAY_PIXELS
  shortPause := DEFAULT_SHORT_PAUSE
  'horizontalScrollDelay := DEFAULT_H_SCROLL_DELAY * MS_001
  scrollSpeed := DEFAULT_SCROLL_SPEED
  horizontalScrollDelay := SetSpeed(scrollSpeed)
  pressesPerLed := DEFAULT_PRESS_PER_LED
  waitcnt(clkfreq + cnt)
    
  localCharacter := cognew(LightLeds, @ledStack)        ' uses a cog 1 left
  eepromFontColor := WHITE                                                 
 
  bufferSavedFlag := 1    
  repeat until not lockset(debugLock)
  Pst.Clear
  Pst.Position(TITLE_X, TITLE_Y)
  Pst.str(string("8 x 8 RGB LED Array Demo"))
  Pst.Position(TITLE_X, TITLE_Y + 2)
  Pst.str(string("program name of top object = "))
  Pst.str(@programName)
  Pst.Position(TITLE_X, TITLE_Y + 3)
  'Pst.str(string("program name of LED object = "))
  'Pst.str(Led.GetProgramName)
  'Pst.Position(TITLE_X, TITLE_Y + 4)
  'Pst.str(string("ledCog = "))
  'Pst.dec(ledCog)
  'Pst.str(@activeText)
  lockclr(debugLock)
  SetupEyes
  'Pst.charIn
  waitcnt(clkfreq / 4 + cnt)
 
  MainLoop

PUB MainLoop | colorIndex, brightnessIndex, direction 
''  This method resides in cog 0.  It checks for new information
''  received by other cogs and takes action based on such information.

  timesToFlash := 2
  flashDurationMs := 250
  patternSize := @patternD01 - @patternD02
  direction := 1
  repeat
    MainMenu
    {case menuMode
      MAIN_MENU: MainMenu
      COLOR_MENU: ColorMenu
      NUMBER_MENU: EnterNumber  }
      'TEXT_MENU: TextMenu
      'MESSAGE_MENU: EnterText
      'CHOOSE_CONFIRM_MESSAGE: ConfirmText
      ' ** add option to change timing


PUB MainMenu | localCharacter', combinedFlags, previousCombinedFlags


  'combinedFlags := CombineFlags 
  'previousCombinedFlags := combinedFlags
  DisplayInfo
  repeat until not lockset(debugLock)
  Pst.str(@mainMenuText)
  {if combinedFlags
    Pst.str(@modifyMenu)
    if modifiableColorFlag
      Pst.str(@modifyColor)
    if modifiableNumberFlag
      Pst.str(@modifyNumber)
    if modifiableBrightnessFlag
      Pst.str(@modifyBrightness)
  Pst.str(@modifyFont) }   
  lockclr(debugLock)
  'DumpBuffer(@displayBuffer, displayBytes)
  
  repeat  
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
        
      case localCharacter
        "S", "s": '">", ".": '"O", "o":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          modifiableBrightnessFlag := 0
          ledMode := OFF_MODE
       { 
        "S", "s":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 0
          modifiableBrightnessFlag := 1
          ledMode := SOLID_MODE
       
         }
        "P", "p":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := PULSE_MODE            
        "D", "d":
          modifiableColorFlag := 1
          modifiableNumberFlag := 1
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := SOLID_MODE            
        "A", "a":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := PATTERN_MODE
        "L", "l":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := CYCLE_MODE
        "I", "i":
          'modifiableColorFlag := 0
          'modifiableNumberFlag := 0
          'activeLedsUpperLimit := DISPLAY_PIXELS 
          'activeLedsLowerLimit := 1
          'modifiableBrightnessFlag := 1
          ledMode := GRAPH_MODE
          spaceCount := 0
          DisplayTempData
        {"H", "h":
          modifiableColorFlag := 0
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          ledMode := RAINBOW_ANGLED_MODE     }
          
        "T", "t":
          modifiableColorFlag := 1
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          menuMode := MAIN_MENU  'TEXT_MENU
          ledMode := TEXT_MODE
          activeColorIndex #>= RED
          activeColorIndex <#= RAINBOW
          
        "X", "x":
          modifiableColorFlag := 1
          modifiableNumberFlag := 0
          activeLedsUpperLimit := DISPLAY_PIXELS 
          activeLedsLowerLimit := 1
          modifiableBrightnessFlag := 1
          menuMode := MAIN_MENU
          activeColorIndex := RAINBOW 
          ledMode := TEXT_MODE
          
       { "C", "c":
          if modifiableColorFlag
            menuMode := COLOR_MENU
        "N", "n":
          if modifiableNumberFlag
            menuMode := NUMBER_MENU  }   
        "+":
          if modifiableBrightnessFlag
            result := brightness + SMALL_BRIGHTNESS_CHANGE
            brightness :=  result <# DEFAULT_MAX_BRIGHTNESS
            DisplayBrightness
        "-":
          if modifiableBrightnessFlag
            result := brightness - SMALL_BRIGHTNESS_CHANGE
            brightness :=  result #> DEFAULT_MIN_BRIGHTNESS
            DisplayBrightness
        "*":
          if modifiableBrightnessFlag
            result := brightness + LARGE_BRIGHTNESS_CHANGE
            brightness :=  result <# DEFAULT_MAX_BRIGHTNESS
            DisplayBrightness
        "/":
          if modifiableBrightnessFlag
            result := brightness - LARGE_BRIGHTNESS_CHANGE
            brightness :=  result #> DEFAULT_MIN_BRIGHTNESS
            DisplayBrightness
        "4":
          result := scrollSpeed - SMALL_SPEED_CHANGE
          scrollSpeed :=  result #> MIN_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed
        "6":
          result := scrollSpeed + SMALL_SPEED_CHANGE
          scrollSpeed :=  result <# MAX_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed
        "2":
          result := scrollSpeed - LARGE_SPEED_CHANGE
          scrollSpeed :=  result #> MIN_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed
        "8":
          result := scrollSpeed + LARGE_SPEED_CHANGE
          scrollSpeed :=  result <# MAX_SCROLL_SPEED
          horizontalScrollDelay := SetSpeed(scrollSpeed)
          DisplaySpeed   
        "0":
          activeFont := FREE_DESIGN
        "1":
          activeFont := SIMPLYTRONICS_0508
        "3":
          result := activeArrays - 1
          activeArrays := result #> MIN_ALLOWED_ARRAYS
          previousLedMode := ledMode
          ledMode := CHANGE_ARRAYS_MODE
          'Led.ChangeSize(1, Led#YES_RESTART)
          DisplayActiveArrays
        "5":
          result := activeArrays + 1
          activeArrays := result <# MAX_ALLOWED_ARRAYS
          previousLedMode := ledMode
          ledMode := CHANGE_ARRAYS_MODE
          'Led.ChangeSize(2, Led#YES_RESTART)
          DisplayActiveArrays
        "7":
          result := resolution - 1
          resolution := result #> Led#MIN_BITS_OF_RESOLUTION
          tempDataFlag := ledMode := CHANGE_RESOLUTION_MODE
          DisplayResolution
        "9":
          result := resolution + 1
          resolution := result <# Led#MAX_BITS_OF_RESOLUTION
          previousLedMode := ledMode
          ledMode := CHANGE_RESOLUTION_MODE
          DisplayResolution
        "R", "r":
          activeColorIndex := RED
          menuMode := MAIN_MENU
        "O", "o":
          activeColorIndex := ORANGE
          menuMode := MAIN_MENU
        "Y", "y":
          activeColorIndex := YELLOW
          menuMode := MAIN_MENU
        "G", "g":
          activeColorIndex := GREEN
          menuMode := MAIN_MENU
        "B", "b":
          activeColorIndex := BLUE
          menuMode := MAIN_MENU
        "I", "i":
          activeColorIndex := INDIGO
          menuMode := MAIN_MENU
        "V", "v":
          activeColorIndex := VIOLET
          menuMode := MAIN_MENU
        "W", "w":
          activeColorIndex := WHITE
          menuMode := MAIN_MENU
        "@", ")", "!", "(", "#", "^", "{", "}", "|", "[", "_", "]":
          activeEye := lookdownz(localCharacter: "@", ")", "!", "(", "#", "^", "{", "}", {
                                               } "|", "[", "_", "]")
          repeat until not lockset(debugLock)
          Debug
          Pst.str(string("You entered ", 34))
          SafeChar(localCharacter)
          Pst.Char(34)
          Pst.str(string(", activeEye = "))
          Pst.Dec(activeEye)       
          lockclr(debugLock)
          'repeat while ledMode == EYES_MODE
          ledMode := EYES_MODE
          
        {"X", "x":
          activeColorIndex := RAINBOW
          menuMode := MAIN_MENU  }        
        other:
          DisplayNotValid(localCharacter)
          quit
      'combinedFlags := CombineFlags
      
  while menuMode == MAIN_MENU or ledMode == GRAPH_MODE or ledMode == CHANGE_ARRAYS_MODE or {
  } ledMode == CHANGE_RESOLUTION_MODE
  'and tempDataFlag == 0   

PUB Debug
'' Moves debug location to next line and to the right of the menu area.
'' Debug lock should be set prior to calling this method.

  if debugY == MAX_DEBUG_Y
    debugY := 0
    repeat result from 1 to CLEARED_DEBUG_LINES 
      Pst.Position(DEBUG_X, debugY + result)
      Pst.ClearEnd
  else
    debugY++
    Pst.Position(DEBUG_X, debugY + CLEARED_DEBUG_LINES)
    Pst.ClearEnd
    
  Pst.Position(DEBUG_X, debugY)
  Pst.ClearEnd
  
  result := debugY
    
PUB DisplayNotValid(localCharacter)

  if ledMode == GRAPH_MODE and localCharacter == 32
    spaceCount++    
    return
  repeat until not lockset(debugLock)
  Pst.str(string(13, "You entered ", 34))
  SafeChar(localCharacter)
  Pst.Char(34)
  Pst.Char(13)
  Pst.Char(34)
  SafeChar(localCharacter)
  Pst.Str(string(34, " is not a valid command."))
  Pst.str(string(13, "Please enter different command."))
  lockclr(debugLock)
  Pause(2_000)
  
PUB SafeChar(localCharacter)

  if localCharacter > LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
    Pst.Char(localCharacter)
  else
    Pst.Char("$")
    Pst.Hex(localCharacter, 2)
    
{PUB ColorMenu | localCharacter, combinedFlags, previousCombinedFlags

  
  repeat until not lockset(debugLock)
  Pst.str(@colorMenuText)
  lockclr(debugLock)

  repeat  
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
        
      case localCharacter
        "R", "r":
          activeColorIndex := RED
          menuMode := MAIN_MENU
        "O", "o":
          activeColorIndex := ORANGE
          menuMode := MAIN_MENU
        "Y", "y":
          activeColorIndex := YELLOW
          menuMode := MAIN_MENU
        "G", "g":
          activeColorIndex := GREEN
          menuMode := MAIN_MENU
        "B", "b":
          activeColorIndex := BLUE
          menuMode := MAIN_MENU
        "I", "i":
          activeColorIndex := INDIGO
          menuMode := MAIN_MENU
        "V", "v":
          activeColorIndex := VIOLET
          menuMode := MAIN_MENU
        "W", "w":
          activeColorIndex := WHITE
          menuMode := MAIN_MENU
        "X", "x":
          activeColorIndex := RAINBOW
          menuMode := MAIN_MENU
      
  while menuMode == COLOR_MENU
}           
PUB LoadText(localPtr) | localIndex, showFlag, localCharacter', eeStart', controlCount
  'LOWEST_ASCII_USED = 32
  'HIGHEST_ASCII_USED = 126
  'DEFAULT_SPACE_BETWEEN_LETTERS = 3
  'DEFAULT_N_SPACING = 6
  activeCharacter := 32
  stScrollIndex := 0
  'controlCount := 0
  repeat 
    'showFlag := 0
    'if controlCount > 1
    '  controlCount--
    if ledMode <> TEXT_MODE 'and ledMode <> RAINBOW_TEXT_MODE
      abort
    
    localCharacter := byte[localPtr++]
    
    ' Check for control characters
    if localCharacter < 32      
      if localCharacter == SET_FONT
        activeFont := byte[localPtr++]
        'controlCount := 1
      elseif localCharacter == SET_DELAY
        horizontalScrollDelay := byte[localPtr++]
        'controlCount := 1        
      elseif localCharacter == SET_BRIGHTNESS
        brightness := byte[localPtr++]
        DisplayBrightness
        'controlCount := 1        
      {elseif localCharacter == SET_BRIGHTNESS_ST
        brightnessSt := byte[localPtr++]
        customSettingL := ModifyBrightnessSt(brightnessSt)    }
        'controlCount := 1
      elseif localCharacter == SET_FOREGROUND_COLOR
        activeColorIndex := byte[localPtr++]
        GetColors(activeColorIndex, @characterColors)
        'originalCustomSettingL := blackSettingL[activeColorIndex]
        'customSettingL := ModifyBrightnessSt(brightnessSt)
        
        'controlCount := 1
      elseif localCharacter == SET_BACKGROUND_COLOR
        bytemove(@pBackground, @background, 3)
        'pBackgroundL := backgroundL
        'background := blackSetting[byte[localPtr++]]
        'backgroundL := blackSettingL[activeColorIndex]
        'controlCount := 1
      elseif localCharacter == SET_FOREGROUND_RGB
        activeColorIndex := CUSTOM_COLOR
        {originalCustomSettingL := BuildLongColor(byte[localPtr++], byte[localPtr++], {
        } byte[localPtr++])
        customSettingL := ModifyBrightnessSt(brightnessSt)
        FillThreeBytesFromLongColor(@customSetting, customSettingL) }
        'controlCount := 1
      elseif localCharacter == SET_BACKGROUND_RGB
        activeColorIndex := CUSTOM_COLOR
        {backgroundL := BuildLongColor(byte[localPtr++], byte[localPtr++], byte[localPtr++])
        FillThreeBytesFromLongColor(@background, backgroundL)  }
        'controlCount := 1
        
    ' Check for displayed characters.       
    elseif localCharacter == 32
      ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
    else  
      previousCharacter := activeCharacter
      activeCharacter := localCharacter
      pStScrollIndex := stScrollIndex
      'pactiveColorIndexL := customSettingL
      {repeat until not lockset(debugLock)
      Pst.str(string(13, "activeCharacter = "))
      Pst.char(activeCharacter)  
      lockclr(debugLock)         }
    'if localCharacter => LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
      'if localCharacter == 32
        'ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
      if activeCharacter <> previousCharacter
        BuildCharacter(activeFont, localCharacter, activeColorIndex)
      ScrollSpace(DEFAULT_SPACE_BETWEEN_LETTERS)   
      ScrollFontHorizontal
    
    if overTimeFlag
      Pst.str(string(13, "************* overTimeFlag = "))
      Pst.dec(overTimeFlag)
      Pst.str(string(" *************")) 
      overTimeFlag := 0
  while localCharacter 'or controlCount
       
PUB BuildCharacter(font, characterIndex, fontColor): size | widthIndex, heightIndex, rowOfFontBits, {
              } furthestRightBit, mostSigBit, bitToSubtract, wideFontIndex, {
              } localPtr, rowOfFontPtr, bitToCheck, columnIndex,{ incrementIndex
              } characterWidth, columnPtr
'' This method reads the bits making up a character and fills the buffer "fontSpace" with bytes representing
'' the various bits.
              
  bytefill(@fontSpace, 0, FONT_BYTES_IN_EEPROM)
 
  characterIndex -= LOWEST_ASCII_USED
  furthestRightBit := fontWidth[font] 'FONT_WIDTH
  characterWidth := FindCharacterWidth(font, characterIndex)
  {repeat until not lockset(debugLock)
  Pst.str(string(13, "characterWidth = "))
  Pst.dec(characterWidth)
  Pst.Str(string(13, "nextColors = "))
  lockclr(debugLock)   }
  'DisplayColorBytes(@nextColors)
  
  if characterWidth
    characterWidth--
  else
    return  
  if fontColor == RAINBOW    
    {repeat until not lockset(debugLock)
    Pst.str(string(13, "rainbow colors:"))
    lockclr(debugLock)  }
    columnPtr := @columnColors
    repeat result from 0 to characterWidth
      columnPtr := IncrementColors(columnPtr, @characterColors, @pseudoColorIncrement, {
      } rainbowTransitionIndex)
      
      TransitionRainbow
      'incrementIndex := rainbowTransitionIndex - 1
  else
    AdjustBrightness(@blackSetting + (TRI_COLOR * fontColor), @characterColors, brightness)
    {repeat until not lockset(debugLock)
    Pst.str(string(13, "Non-rainbow color = "))
    lockclr(debugLock)  }
    'DisplayColorBytes(@characterColors)   
    
  

  ' Build font row by row but rainbow colors change by column.
  ' Use array to hold colors in each row.
  rowOfFontPtr := fontPtr[font] + (characterIndex * fontHeight[font]) 
  repeat heightIndex from 0 to fontHeight[font] - 1
    {rowOfFontBits := byte[fontPtr[font] + (characterIndex * fontHeight[font]) + {
    } ((fontHeight[font] - 1) - heightIndex)]      }
    rowOfFontBits := byte[rowOfFontPtr++]
    if heightIndex or fontColor <> RAINBOW
      {repeat until not lockset(debugLock) 
      Pst.str(string(13, "rowOfFontBits = %"))
      'Pst.dec( rowOfFontBits)
      Pst.bin(rowOfFontBits, 8)
      lockclr(debugLock)  }  
    bitToCheck := 1 << 7
    
    repeat columnIndex from 0 to characterWidth
      if heightIndex == 0 and fontColor == RAINBOW
        {repeat until not lockset(debugLock)
        Pst.str(string(13, "rowOfFontBits = %"))
        Pst.bin(rowOfFontBits, 8)
        Pst.str(string(13, "columnIndex = "))
        Pst.Dec(columnIndex)
        Pst.Str(string(13, "BuildCharacter characterColors = "))
        lockclr(debugLock)  }
        'DisplayColorBytes(@characterColors)
        {repeat until not lockset(debugLock)
        Pst.Str(string(13, "nextColors = "))
        lockclr(debugLock)  }
        'DisplayColorBytes(@nextColors)
      if bitToCheck & rowOfFontBits  
        localPtr := @fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
        } (TRI_COLOR * columnIndex)  
        if fontColor == RAINBOW
          columnPtr := @columnColors + (TRI_COLOR * columnIndex)
          bytemove(localPtr, columnPtr, TRI_COLOR)
          {repeat until not lockset(debugLock)
          Pst.str(string(13, "columnIndex = "))
          Pst.Dec(columnIndex)
          Pst.Str(string(", localPtr Colors = "))
          lockclr(debugLock)  }
          'DisplayColorBytes(localPtr)
        
        else
          bytemove(localPtr, @characterColors, TRI_COLOR)  
        
      bitToCheck >>= 1 
    
  
  fontSpace[FONT_BYTES_PER_CHARACTER] := size := characterWidth + 1
  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "****** Exit BuildCharacter Method ******"))
  Pst.Str(string(13, "nextColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@nextColors)
   
PRI TransitionRainbow

  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "****** Enter TransitionRainbow Method ******"))
  Pst.Str(string(13, "nextColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@nextColors)
  
  if rainbowTransitionIndex == colorTransitions   ' colorTransitions - 1? No, zero doesn't count
    rainbowTransitionIndex := 0                   ' in this instance zero is not a transitional
    rainbowIndex := nextRainbowIndex              ' color.
    if nextRainbowIndex == LAST_RAINBOW_COLOR
      nextRainbowIndex := FIRST_RAINBOW_COLOR
    else
      nextRainbowIndex++
    
    {repeat until not lockset(debugLock)
    Pst.Str(string(13, "rainbowIndex = "))
    Pst.str(GetColorName(rainbowIndex))
    Pst.Str(string(", nextRainbowIndex = ")) 
    Pst.str(GetColorName(nextRainbowIndex))
    lockclr(debugLock)  } 
    bytemove(@characterColors, @nextColors, TRI_COLOR)
    GetColors(nextRainbowIndex, @nextColors)
    {repeat until not lockset(debugLock)
    Pst.Str(string(13, "before adjustment nextColors = "))
    lockclr(debugLock)  }
    'DisplayColorBytes(@nextColors) 
    AdjustBrightness(@nextColors, @nextColors, brightness)   
    {repeat until not lockset(debugLock)
    Pst.Str(string(13, "after adjustment nextColors = "))
    lockclr(debugLock)  }
    'DisplayColorBytes(@nextColors) 
    {repeat until not lockset(debugLock)
    Pst.Str(string(13, "previous characterColors = "))
    lockclr(debugLock)  }
    'DisplayColorBytes(@characterColors)
    GetColors(rainbowIndex, @characterColors) 
    {repeat until not lockset(debugLock)
    Pst.Str(string(13, "fixed characterColors = "))
    lockclr(debugLock)  }
    'DisplayColorBytes(@characterColors) 
    FindIncrementalColors(@characterColors, @nextColors, @pseudoColorIncrement, colorTransitions + 1)   
  else
    rainbowTransitionIndex++
 
  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "TransitionRainbow characterColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@characterColors)        
  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "nextColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@nextColors)
  {rainbowIndex := FIRST_RAINBOW_COLOR
  nextRainbowIndex := rainbowIndex + 1
  GetColors(nextRainbowIndex, @nextColors)
  GetColors(rainbowIndex, @characterColors)}    
  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "****** Exit TransitionRainbow Method ******"))
  Pst.Str(string(13, "nextColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@nextColors)
    
PRI FindCharacterWidth(font, characterIndex) | heightIndex, lastHeightIndex, bitIndex, {
                                             } bitToCheck, rowOfBits, lowestBit, {
                                             } rowOfFontPtr, lastBitIndex
  {
  case font
    FREE_DESIGN:
      result := string("FREE_DESIGN       ")
    SIMPLYTRONICS_0508:
      result := string("SIMPLYTRONICS_0508")
    SIMPLYTRONICS_0816:
      result := string("SIMPLYTRONICS_0816")
   }       
  lastHeightIndex := fontHeight[font] - 1
  lowestBit := 8          '** make generic for other possible widths.
  lastBitIndex := lowestBit - 1
  rowOfFontPtr := fontPtr[font] + (characterIndex * fontHeight[font]) 
  repeat heightIndex from 0 to lastHeightIndex 
    rowOfBits := byte[rowOfFontPtr++]
    bitToCheck := 1
    repeat bitIndex from 0 to lastBitIndex 'lastBitIndex '** make generic for other possible widths.
      if bitToCheck & rowOfBits
        lowestBit := bitIndex
        lastBitIndex := lowestBit - 1
        {repeat until not lockset(debugLock)       
        Pst.str(string(13, "lowestBit = "))
        Pst.dec(lowestBit)
        lockclr(debugLock)  }  
        quit     
      else
        bitToCheck <<= 1
    if lastBitIndex == -1
      {repeat until not lockset(debugLock)
      Pst.str(string(13, "lastBitIndex = "))
      Pst.dec(lastBitIndex)
      lockclr(debugLock)  }
      quit
  result := 8 - lowestBit
      
PUB IncrementColors(destinationPtr, baseColorPtr, incrementalPtr, incrementIndex)

  if incrementIndex
    byte[destinationPtr][RED_PORTION] := byte[baseColorPtr][RED_PORTION] + {
    } ((long[incrementalPtr][RED_PORTION] * incrementIndex) / PSEUDO_MULTIPLIER)
    byte[destinationPtr][GREEN_PORTION] := byte[baseColorPtr][GREEN_PORTION] + {
    } ((long[incrementalPtr][GREEN_PORTION] * incrementIndex) / PSEUDO_MULTIPLIER)
    byte[destinationPtr][BLUE_PORTION] := byte[baseColorPtr][BLUE_PORTION] + {
    } ((long[incrementalPtr][BLUE_PORTION] * incrementIndex) / PSEUDO_MULTIPLIER)
  else
    bytemove(destinationPtr, baseColorPtr, TRI_COLOR)
  {repeat until not lockset(debugLock)
  Pst.str(string(13, "incrementIndex = "))
  Pst.dec(incrementIndex)
  Pst.str(string(13, "base colors = "))
  lockclr(debugLock)  }  
  'DisplayColorBytes(baseColorPtr)
  {repeat until not lockset(debugLock)
  Pst.str(string(13, "destination colors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(destinationPtr)
  {repeat until not lockset(debugLock)
  Pst.str(string(13, "increment colors = "))
  Pst.dec(long[incrementalPtr][0])
  Pst.str(string(", "))
  Pst.dec(long[incrementalPtr][1])
  Pst.str(string(", "))
  Pst.dec(long[incrementalPtr][2])
  lockclr(debugLock)  }
  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "IncrementColors characterColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@characterColors)
  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "nextColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@nextColors)      
  result := destinationPtr + TRI_COLOR
  
PUB DisplayColorBytes(localPtr)

  repeat until not lockset(debugLock)
  Pst.char("$")
  Pst.hex(byte[localPtr][RED_PORTION], 2)
  Pst.str(string(", $"))
  Pst.hex(byte[localPtr][GREEN_PORTION], 2)  
  Pst.str(string(", $")) 
  Pst.hex(byte[localPtr][BLUE_PORTION], 2)  
  lockclr(debugLock)  
  
PUB FindIncrementalColors(initialColorsPtr, finalColorsPtr, incrementalPtr, localSize)
'' localSize should include the initialColor but not finalColor.
'' The debug lock should be set prior to calling this method.

  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "FindIncrementalColors Method ******")) }
  {Pst.Str(string(ASCII_CR, "initialColor = "))
  Hex(initialColor)
  Pst.Str(string(ASCII_CR, "finalColor = "))
  Hex(finalColor) }

  ' find incremental color change
  ' use the "PSEUDO_MULTIPLIER" mulitplier to reduce rounding errors
  ' Note we divide by multiplier prior to assigning color
  ' to buffer.
  repeat result from 0 to 2
    long[incrementalPtr][result] := ((byte[finalColorsPtr][result] - {
    } byte[initialColorsPtr][result])* PSEUDO_MULTIPLIER) / localSize 
    {Pst.Str(string(13, "long[incrementalPtr]["))
    Pst.Dec(result)
    Pst.Str(string("] = "))
    Pst.Dec(long[incrementalPtr][result])

  lockclr(debugLock)  }
  {repeat until not lockset(debugLock)
  Pst.Str(string(13, "FindIncrementalColors nextColors = "))
  lockclr(debugLock)  }
  'DisplayColorBytes(@nextColors)
  
PUB AdjustBrightness(initialColorPtr, finalColorPtr, localBrightness)

  byte[finalColorPtr + RED_PORTION] := (byte[initialColorPtr + RED_PORTION] * {
  } localBrightness) / DEFAULT_MAX_BRIGHTNESS
  byte[finalColorPtr + GREEN_PORTION] := (byte[initialColorPtr + GREEN_PORTION] * {
  }localBrightness) / DEFAULT_MAX_BRIGHTNESS
  byte[finalColorPtr + BLUE_PORTION] := (byte[initialColorPtr + BLUE_PORTION] * {
  } localBrightness) / DEFAULT_MAX_BRIGHTNESS
 
{PUB LoadRainbowText(localPtr, localSize) | localIndex, showFlag, localCharacter, eeStart
  'LOWEST_ASCII_USED = 32
  'HIGHEST_ASCII_USED = 126
  'DEFAULT_SPACE_BETWEEN_LETTERS = 3
  'DEFAULT_N_SPACING = 6
  repeat localSize
    showFlag := 0
    ScrollSpace(DEFAULT_SPACE_BETWEEN_LETTERS)
    localCharacter := byte[localPtr++]
    if ledMode <> RAINBOW_TEXT_MODE
      abort
    if localCharacter => LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
      if localCharacter == 32
        ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
      else
        eeStart := EEPROM_FONT_ADDRESS + (FONT_BYTES_IN_EEPROM * (localCharacter - LOWEST_ASCII_USED))
        Eeprom.ToRam(@fontSpace, @fontSpace + FONT_BYTES_PER_CHARACTER, eeStart)
        ScrollRainbowFontHorizontal
      
PUB LoadTextFont(localPtr, localSize, localFont) | localIndex, showFlag, localCharacter, eeStart
  'LOWEST_ASCII_USED = 32
  'HIGHEST_ASCII_USED = 126
  'DEFAULT_SPACE_BETWEEN_LETTERS = 3
  'DEFAULT_N_SPACING = 6
  repeat localSize
    showFlag := 0
    ScrollSpace(DEFAULT_SPACE_BETWEEN_LETTERS)
    localCharacter := byte[localPtr++]
    if ledMode <> RAINBOW_TEXT_MODE
      abort
    if localCharacter => LOWEST_ASCII_USED and localCharacter =< HIGHEST_ASCII_USED
      if localCharacter == 32
        ScrollSpace(DEFAULT_N_SPACING - DEFAULT_SPACE_BETWEEN_LETTERS)
      else
        eeStart := EEPROM_FONT_ADDRESS + (FONT_BYTES_IN_EEPROM * (localCharacter - LOWEST_ASCII_USED))
        Eeprom.ToRam(@fontSpace, @fontSpace + FONT_BYTES_PER_CHARACTER, eeStart)
        ScrollRainbowFontHorizontal
}      
PUB ScrollSpace(localSize) | dataToScrollIndex, displayRowIndex, firstByteOfRowPtr, lastOfRowIndex

  {repeat until not lockset(debugLock)
  Pst.str(string(13, "ScrollSpace("))
  Pst.dec(localSize)
  Pst.Char(")")
  lockclr(debugLock)  }
      
  localSize--
  repeat dataToScrollIndex from 0 to localSize
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      firstByteOfRowPtr := @displayBuffer + (displayRowIndex * displayWidthBytes)
      lastOfRowIndex := (displayRowIndex * displayWidthBytes) + {
        } displayWidthBytes - TRI_COLOR
      bytemove(firstByteOfRowPtr, firstByteOfRowPtr + TRI_COLOR, displayWidthBytes - TRI_COLOR)
      bytemove(@displayBuffer + lastOfRowIndex, @background, TRI_COLOR)
      'displayBuffer[lastOfRowIndex + BLUE_PORTION] := background[BLUE_PORTION]
      'displayBuffer[lastOfRowIndex + GREEN_PORTION] := background[GREEN_PORTION]
      {byte[@displayBuffer + (displayRowIndex * displayWidthBytes) + displayWidthBytes {
        } - ledType + RED_PORTION] := byte[localPtr + (displayRowIndex * {
        } FONT_EEPROM_BYTE_WIDTH) + (dataToScrollIndex * ledType) + RED_PORTION]
      byte[@displayBuffer + (displayRowIndex * displayWidthBytes) + displayWidthBytes {
        } - ledType + BLUE_PORTION] := byte[localPtr + (displayRowIndex * {
        } FONT_EEPROM_BYTE_WIDTH) + (dataToScrollIndex * ledType) + BLUE_PORTION]
      byte[@displayBuffer + (displayRowIndex * displayWidthBytes) + displayWidthBytes {
        } - ledType + GREEN_PORTION] := byte[localPtr + (displayRowIndex * {
        } FONT_EEPROM_BYTE_WIDTH) + (dataToScrollIndex * ledType) + GREEN_PORTION]
     } 
    'bytemove(@doubleBuffer, @displayBuffer, FONT_BYTES_PER_CHARACTER)
    'DumbBuffer(@displayBuffer, 12, 10, 4)
    {if activeFont == SIMPLYTRONICS_0508
      stScrollIndex--
      pStScrollIndex-- 
      'Pst.str(string(13, "stScrollIndex = "))
      'Pst.dec(stScrollIndex) 
      RGB.ASCII_0508(activeCharacter, stScrollIndex, 0, customSettingL, backgroundL)
      RGB.ASCII_0508(previousCharacter, pStScrollIndex, 0, pactiveColorIndexL, backgroundL)
      RGB.UpdateScreen
      'Pst.CharIn
    elseif activeFont == FREE_DESIGN
      stScrollIndex--
      pStScrollIndex-- 
      RGB.ASCII_0816(activeCharacter, stScrollIndex, 0, customSettingL, backgroundL)
      RGB.ASCII_0816(previousCharacter, pStScrollIndex, 0, pactiveColorIndexL, backgroundL)
      RGB.UpdateScreen     }
    'Pause(horizontalScrollDelay)
    IncrementTime(horizontalScrollDelay)
                                                                                 
PUB ScrollFontHorizontal| dataToScrollIndex, displayRowIndex, firstByteOfRowPtr, {
                        } lastOfRowIndex, fontColumnToDisplay, localSize

  localSize := fontSpace[FONT_BYTES_PER_CHARACTER]
  repeat dataToScrollIndex from 0 to localSize - 1
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      if ledMode <> TEXT_MODE 'and ledMode <> RAINBOW_TEXT_MODE
        abort
      firstByteOfRowPtr := @displayBuffer + (displayRowIndex * displayWidthBytes)
      lastOfRowIndex := (displayRowIndex * displayWidthBytes) + {
        } displayWidthBytes - TRI_COLOR
      fontColumnToDisplay := (displayRowIndex * FONT_EEPROM_BYTE_WIDTH) + {
        } (dataToScrollIndex * TRI_COLOR) 
      bytemove(firstByteOfRowPtr, firstByteOfRowPtr + ledType, displayWidthBytes - TRI_COLOR)
      bytemove(@displayBuffer + lastOfRowIndex, @fontSpace + fontColumnToDisplay, TRI_COLOR)
      'displayBuffer[lastOfRowIndex + RED_PORTION] := fontSpace[fontColumnToDisplay + RED_PORTION] 
      'displayBuffer[lastOfRowIndex + BLUE_PORTION] := fontSpace[fontColumnToDisplay + BLUE_PORTION]
      'displayBuffer[lastOfRowIndex + GREEN_PORTION] := fontSpace[fontColumnToDisplay + GREEN_PORTION]
    {  
    if pActiveFont == SIMPLYTRONICS_0508
      pStScrollIndex--  
      RGB.ASCII_0508(previousCharacter, pStScrollIndex, 0, pactiveColorIndexL, backgroundL)
    elseif pActiveFont == FREE_DESIGN
      pStScrollIndex-- 
      RGB.ASCII_0816(previousCharacter, pStScrollIndex, 0, pactiveColorIndexL, backgroundL)
    if activeFont == SIMPLYTRONICS_0508
      stScrollIndex := fontSpace[FONT_BYTES_PER_CHARACTER] + 2 - dataToScrollIndex
      'Pst.str(string(13, "dataToScrollIndex = "))
      'Pst.dec(dataToScrollIndex) 
      'Pst.str(string(13, "stScrollIndex = "))
      'Pst.dec(stScrollIndex) 
      RGB.ASCII_0508(activeCharacter, stScrollIndex, 0, customSettingL, backgroundL) 
      RGB.UpdateScreen
      'Pst.CharIn
    elseif activeFont == FREE_DESIGN
      stScrollIndex := fontSpace[FONT_BYTES_PER_CHARACTER] + 2 - dataToScrollIndex
      RGB.ASCII_0816(activeCharacter, stScrollIndex, 0, customSettingL, backgroundL) 
      RGB.UpdateScreen   }
      
    'Pause(horizontalScrollDelay)
    IncrementTime(horizontalScrollDelay)
  pActiveFont := activeFont
  pactiveColorIndex := activeColorIndex
                                                                                
{PUB ScrollRainbowFontHorizontal| dataToScrollIndex, displayRowIndex, firstByteOfRowPtr, {
                        } lastOfRowIndex, fontColumnToDisplay, localSize

  'DEFAULT_COLOR_TRANSITIONS = 8
  'rainbowIndex, rainbowTransitionIndex
  'colorTransition[TRI_COLOR]
  'globalColor[TRI_COLOR]
  
  localSize := fontSpace[FONT_BYTES_PER_CHARACTER]
  repeat dataToScrollIndex from 0 to localSize - 1
    if ++rainbowTransitionIndex == colorTransitions
      rainbowTransitionIndex := 0
      result := rainbowIndex
      if ++rainbowIndex > VIOLET 'WHITE
        rainbowIndex := RED
      

      'repeat until not lockset(debugLock)
      'Pst.str(string(13, "color = "))
      'Pst.str(GetColorName(rainbowIndex))
      'lockclr(debugLock)
      'Pause(500)
        
      globalColor[RED_PORTION] := blackSetting[(result * TRI_COLOR) + RED_PORTION] * 10
      globalColor[GREEN_PORTION] := blackSetting[(result * TRI_COLOR) + GREEN_PORTION] * 10
      globalColor[BLUE_PORTION] := blackSetting[(result * TRI_COLOR) + BLUE_PORTION] * 10
      colorTransition[RED_PORTION] := ((blackSetting[(rainbowIndex * TRI_COLOR) + {
        }RED_PORTION] * 10) - globalColor[RED_PORTION])  / colorTransitions
      colorTransition[BLUE_PORTION] := ((blackSetting[(rainbowIndex * TRI_COLOR) + {
        }BLUE_PORTION] * 10) - globalColor[BLUE_PORTION]) / colorTransitions
      colorTransition[GREEN_PORTION] := ((blackSetting[(rainbowIndex * TRI_COLOR) + {
        }GREEN_PORTION] * 10) - globalColor[GREEN_PORTION]) / colorTransitions
    else
      globalColor[RED_PORTION] += colorTransition[RED_PORTION]
      globalColor[BLUE_PORTION] += colorTransition[BLUE_PORTION]
      globalColor[GREEN_PORTION] += colorTransition[GREEN_PORTION]   
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      if ledMode <> RAINBOW_TEXT_MODE
        abort
      firstByteOfRowPtr := @displayBuffer + (displayRowIndex * displayWidthBytes)
      lastOfRowIndex := (displayRowIndex * displayWidthBytes) + {
        } displayWidthBytes - ledType
      fontColumnToDisplay := (displayRowIndex * FONT_EEPROM_BYTE_WIDTH) + {
        } (dataToScrollIndex * ledType) 
      bytemove(firstByteOfRowPtr, firstByteOfRowPtr + ledType, displayWidthBytes - ledType)
      if fontSpace[fontColumnToDisplay + RED_PORTION]
        displayBuffer[lastOfRowIndex + RED_PORTION] := globalColor[RED_PORTION] / 10
      else
        displayBuffer[lastOfRowIndex + RED_PORTION] := 0 ' ** could use a background color instead
      if fontSpace[fontColumnToDisplay + BLUE_PORTION]
        displayBuffer[lastOfRowIndex + BLUE_PORTION] := globalColor[BLUE_PORTION] / 10
      else
        displayBuffer[lastOfRowIndex + BLUE_PORTION] := 0
      if fontSpace[fontColumnToDisplay + GREEN_PORTION]
        displayBuffer[lastOfRowIndex + GREEN_PORTION] := globalColor[GREEN_PORTION] / 10
      else
        displayBuffer[lastOfRowIndex + GREEN_PORTION] := 0
  
    'Pause(horizontalScrollDelay)
    IncrementTime(horizontalScrollDelay)
}                                                                                 
{PUB ScrollHorizontalOld(localSpace, localSize, localPtr) | dataToScrollIndex, displayRowIndex
' ScrollHorizontal(_DefaultSpaceBetweenLetters, fontSpace[120], @fontSpace)
  '_DefaultSpaceBetweenLetters = 3
  'DEFAULT_N_SPACING = 6
  'bytemove(@displayBuffer + FONT_BYTES_PER_CHARACTER, localPtr, FONT_BYTES_PER_CHARACTER)
  localSize += localSpace
  'localSize <#= _LineLength
  repeat dataToScrollIndex from 0 to localSize - 1
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      bytemove(@displayBuffer + (displayRowIndex * displayWidthBytes), @displayBuffer + {
        } (displayRowIndex * displayWidthBytes) + ledType, displayWidthBytes - ledType)
      byte[@displayBuffer + (displayRowIndex * displayWidthBytes) + displayWidthBytes {
        } - ledType + RED_PORTION] := byte[localPtr + (displayRowIndex * {
        } FONT_EEPROM_BYTE_WIDTH) + (dataToScrollIndex * ledType) + RED_PORTION]
      byte[@displayBuffer + (displayRowIndex * displayWidthBytes) + displayWidthBytes {
        } - ledType + BLUE_PORTION] := byte[localPtr + (displayRowIndex * {
        } FONT_EEPROM_BYTE_WIDTH) + (dataToScrollIndex * ledType) + BLUE_PORTION]
      byte[@displayBuffer + (displayRowIndex * displayWidthBytes) + displayWidthBytes {
        } - ledType + GREEN_PORTION] := byte[localPtr + (displayRowIndex * {
        } FONT_EEPROM_BYTE_WIDTH) + (dataToScrollIndex * ledType) + GREEN_PORTION]
      
    'bytemove(@doubleBuffer, @displayBuffer, FONT_BYTES_PER_CHARACTER)
    'DumbBuffer(@displayBuffer, 12, 10, 4)
  
    Pause(horizontalScrollDelay)
}      
{PUB BuildFont(fontColor) : eeStart | characterIndex, widthIndex, heightIndex, rowOfFontBits, {
              } furthestRightBit, mostSigBit, bitToSubtract, wideFontIndex

  eeStart := EEPROM_FONT_ADDRESS
  repeat characterIndex from 0 to (HIGHEST_ASCII_USED - LOWEST_ASCII_USED)'25 '65 to 90
    {furthestRightBit := Pst.RxCount
    if furthestRightBit
      Pst.CharIn
      Pst.CharIn }
    furthestRightBit := FONT_WIDTH
    repeat heightIndex from 0 to FONT_HEIGHT - 1
      rowOfFontBits := byte[@freeDesign032 + (characterIndex * FONT_HEIGHT) + {
      } ((FONT_HEIGHT - 1) - heightIndex)]
      Pst.str(string(13, "rowOfFontBits = %"))
      'Pst.dec( rowOfFontBits)
      Pst.bin(rowOfFontBits, 8)
      'Pst.str(string(", bytes = "))
      repeat 
        mostSigBit := >|rowOfFontBits
        'Pst.str( string(13, "mostSigBit = "))
        {Pst.char("(")
        Pst.dec(mostSigBit)
        Pst.char(")")
        Pst.char(" ")
        }
        if mostSigBit <> 0
          if mostSigBit < furthestRightBit
            furthestRightBit := mostSigBit
          byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + RED_PORTION] := @blackSetting + {
            } (TRI_COLOR * fontColor) + RED_PORTION
          byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + GREEN_PORTION] := @blackSetting + {
            } (TRI_COLOR * fontColor) + GREEN_PORTION
          byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + BLUE_PORTION] := @blackSetting + {
            } (TRI_COLOR * fontColor) + BLUE_PORTION
          {Pst.char("$")
          Pst.hex(byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + RED_PORTION], 8)
          Pst.char(",")
          Pst.char(" ")
          Pst.char("$")
          Pst.hex(byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + GREEN_PORTION], 8)
          Pst.char(",")
          Pst.char(" ")
          Pst.char("$")
          Pst.hex(byte[@fontSpace + (FONT_EEPROM_BYTE_WIDTH * heightIndex) + {
            } (TRI_COLOR * (8 - mostSigBit)) + BLUE_PORTION], 8)
          Pst.char(",")
          Pst.char(" ") }
          {Pst.str( string(13, "fontSpace["))
          Pst.dec( (FONT_WIDTH * heightIndex) + (8 - mostSigBit))
          Pst.str( string("] = "))
          Pst.dec( brightness)  }
          bitToSubtract := 1
          bitToSubtract <<= (mostSigBit - 1)
          rowOfFontBits -= bitToSubtract
      while mostSigBit <> 0
      'Pst.char(13)
      
    fontSpace[FONT_BYTES_PER_CHARACTER] := 9 - furthestRightBit
    Pst.str(string(13, "Font is "))
    Pst.dec(fontSpace[FONT_BYTES_PER_CHARACTER])
    Pst.str(string(" pixels wide."))
    Eeprom.FromRam(@fontSpace, @fontSpace + FONT_BYTES_PER_CHARACTER, eeStart)
    Pst.str( string(13, "eeStart = "))
    Pst.dec(eeStart)
    eeStart += FONT_BYTES_IN_EEPROM
    bytefill(@fontSpace, 0, FONT_BYTES_IN_EEPROM)
}    
  'Eeprom.FromRam(@fontSpace, @fontSpace + 120, eeStart)
  'Pst.str( string(13, "last eeStart = "))
  'Pst.dec( eeStart)
  {
  repeat characterIndex from 0 to (HIGHEST_ASCII_USED - LOWEST_ASCII_USED)
    repeat wideFontIndex from 0 to _WideFontCount - 1
      if characterIndex == wideFontAscii[wideFontIndex] - LOWEST_ASCII_USED
        'Pst.str( string(13, "Building a wide font."))
        eeStart := EEPROM_FONT_ADDRESS + (characterIndex * 121)
        furthestRightBit := 16
          repeat heightIndex from 0 to 9
            'rowOfFontBits := word[@freeDesignWide087 + (wideFontIndex * 20) + (heightIndex * 2)]
            rowOfFontBits := freeDesignWide087[(wideFontIndex * 10) + heightIndex]
            Pst.str(string(13, "Wide rowOfFontBits = "))
            Pst.dec(rowOfFontBits)
            Pst.str(string(", = %"))
            Pst.bin(rowOfFontBits, 16)
            repeat 
              mostSigBit := >|rowOfFontBits
              'Pst.str( string(13, "mostSigBit = "))
              'Pst.dec( mostSigBit)
              if mostSigBit <> 0
                if mostSigBit < furthestRightBit
                  furthestRightBit := mostSigBit
                byte[@fontSpace + (FONT_WIDTH * heightIndex) + (16 - mostSigBit) {+ 4}] := brightness
                {Pst.str( string(13, "fontSpace["))
                Pst.dec( (FONT_WIDTH * heightIndex) + (8 - mostSigBit))
                Pst.str( string("] = "))
                Pst.dec( brightness)  }
                bitToSubtract := 1
                bitToSubtract <<= (mostSigBit - 1)
                rowOfFontBits -= bitToSubtract
            while mostSigBit <> 0
            'Pst.char(13)
            'repeat localIndex[2] from 0 to FONT_WIDTH - 2
              'Pst.dec(byte[@fontSpace + (FONT_WIDTH * heightIndex) + localIndex[2]])
              'Pst.char(44)
              'Pst.char(32)
            'Pst.dec(byte[@fontSpace + (FONT_WIDTH * heightIndex) + FONT_WIDTH - 1])
          fontSpace[120] := 17 - furthestRightBit
          Pst.str( string(13, "Font is "))
          Pst.dec( fontSpace[120])
          Pst.str( string(" pixels wide."))
          Eeprom.FromRam(@fontSpace, @fontSpace + 120, eeStart)
          Pst.str( string(13, "eeStart = "))
          Pst.dec( eeStart)
          eeStart += 121
          bytefill(@fontSpace, 0, 121)
  bytefill(@displayBuffer, 0, 240)
  
PUB EnterNumber

  repeat until not lockset(debugLock)
  Pst.str(@numberMenuText)
  Pst.dec(activeLedsLowerLimit)
  Pst.str(string(" and "))
  Pst.dec(activeLedsUpperLimit)
  Pst.str(string(".        "))
  
  result := Pst.DecIn
  
  Pst.str(string(13, "You entered "))
  Pst.dec(result)
  Pst.str(string(". ", 13))
  if result < activeLedsLowerLimit
    Pst.dec(result)
    Pst.str(string(" is less than the limit of "))
    Pst.dec(activeLedsLowerLimit)
    Pst.str(string(". ", 13))
    Pst.str(string("The value "))
    Pst.dec(activeLedsLowerLimit)
    Pst.str(string(" will be used instead of "))
    Pst.dec(result)
    Pst.str(string(". ", 13))
    result := activeLedsLowerLimit
  elseif result > activeLedsUpperLimit
    Pst.dec(result)
    Pst.str(string(" is greater than the limit of "))
    Pst.dec(activeLedsUpperLimit)
    Pst.str(string(". ", 13))
    Pst.str(string("The value "))
    Pst.dec(activeLedsUpperLimit)
    Pst.str(string(" will be used instead of "))
    Pst.dec(result)
    Pst.str(string(". ", 13))
    result := activeLedsUpperLimit
  activeLeds := result
  lockclr(debugLock)
  menuMode :=MAIN_MENU
}  
PUB CombineFlags

  result := modifiableColorFlag << 2
  result += modifiableNumberFlag << 1
  result += modifiableBrightnessFlag

PRI LightLeds | timeInterval, localPreviousMode, previousColor, previousBrightness, {
              } previousActiveLeds, localSize, previousActiveEye
 
  localPreviousMode := -1
  previousColor := -1
  previousBrightness := -1
  previousActiveLeds := -1

  Rgb.Start(PIN_RX,PIN_TX, 19200)    
  
  'lastLedModeDisplayed := localPreviousMode
  {ledCog := Led.Start(FIRST_ANODE_PIN, SHIFT_CLOCK, SHIFT_LATCH, SHIFT_DATA, @displayBuffer, {
    } ZONE_WIDTH, ZONES, DEFAULT_RESOLUTION_BITS) - 1   }
  ledCog := Led.Start(FIRST_ANODE_PIN, SHIFT_CLOCK, SHIFT_LATCH, SHIFT_DATA, @displayBuffer) - 1
  '#0, OFF_MODE, LARSON_MODE, SOLID_MODE, DRAGON_MODE, TAIL_MODE, ROTATE_MODE, PULSE_MODE, BOW_MODE
    'PATTERN_MODE, CYCLE_MODE
  'lastDisplayTime := cnt
  repeat
    'RefreshDisplay
    
    
    if ledMode <> localPreviousMode or activeColorIndex <> previousColor or {
     } brightness <> previousBrightness or activeLeds <> previousActiveLeds or {
     } activeEye or previousActiveEye                
      localPreviousMode := ledMode
      previousColor := activeColorIndex
      previousBrightness := brightness
      previousActiveLeds := activeLeds
      previousActiveEye := activeEye
      case ledMode         
        OFF_MODE:
          'activeLedsUpperLimit := DISPLAY_PIXELS
          'activeLedsLowerLimit := DISPLAY_PIXELS
          'Solid(BLACK)
          bytefill(@displayBuffer, 0, displayBytes)
        {LARSON_MODE:
          CylonLeds  }      
        SOLID_MODE:
          Solid'(activeColorIndex)
          'FillDisplay(activeColorIndex, brightness)
        {DRAGON_MODE:
          FillTail(activeLeds)
          RotateTail
        TAIL_MODE:
          FillTail(activeLeds)
          BounceTail
        ROTATE_MODE:
          RotateBuffer(1)  }
        PULSE_MODE:
          Pulse         
       { 'BOW_MODE:
        RAINBOW_ANGLED_MODE:
          RainbowAngled(1) }
        PATTERN_MODE:
          Pattern
        CYCLE_MODE:
          CycleColors 
        TEXT_MODE:
          localSize := strsize(@messageBuffer)
          ScrollMessage(@messageBuffer, localSize)
        GRAPH_MODE:
          GraphKeyboard(@graphColumn)
        CHANGE_ARRAYS_MODE:
          Led.ChangeSize(activeArrays, Led#YES_RESTART)
          displayWidthPixels := activeArrays * ARRAY_WIDTH_PIXELS 
          displayWidthBytes := displayWidthPixels * TRI_COLOR
          displayBytes := displayWidthBytes * DISPLAY_HEIGHT
          ledMode := previousLedMode
        CHANGE_RESOLUTION_MODE:
          Led.BitsOfResolution(resolution, Led#YES_RESTART)
          ledMode := previousLedMode
        EYES_MODE:
          result := DisplayEyes
          if result == 0
            ledMode := localPreviousMode 
        {UPDATE_TEXT_MODE:
          ledMode := TEXT_MODE   }
       ' RAINBOW_TEXT_MODE:
       '   localSize := strsize(@messageBuffer)
        '  ScrollRainbowMessage(@messageBuffer, localSize)
        {CYCLE_TEXT_MODE:
          CycleLetters
        WHITE_MODE:
          WhiteAll }
          ' reload messageBuffer
        'other: localPreviousMode := CaseUltrasound(ledMode, localPreviousMode)
{
PUB NumbersToColors(value) | bufferPtr[2], singleDigit, numberToChop, localIndex

  value <#= 9999
  value #>= 0
  if value <> coloredNumber
    coloredNumber := value
    
    bufferPtr[0] := @displayBuffer + NUMBERS_TO_COLORS_OFFSET
    bufferPtr[1] := @tempBuffer + NUMBERS_TO_COLORS_OFFSET
    numberToChop := value
    result := 1000
    localIndex := 0
    repeat 4
      singleDigit := value / result
      bytemove(bufferPtr[0], @colorSet0 + (singleDigit * 3), 3)
      bytemove(bufferPtr[1], @colorSet1 + (singleDigit * 3), 3)
      repeat until not lockset(debugLock)
      Pst.Position(LED_NUMBER_READING_X + (localIndex++ * 3), LED_NUMBER_READING_Y)
      'Pst.str(string(", ["))
      'Pst.dec(localIndex) 
      'Pst.str(string("] = "))
      Pst.dec(singleDigit)
      Pst.str(string(" "))
      lockclr(debugLock)  
      bufferPtr[0] -= 3
      bufferPtr[1] -= 3
      value //= result   
      result /= 10
      
  if bufferInUsePtr == tempBuffer
    bufferInUsePtr := @displayBuffer
  else  
    bufferInUsePtr := @tempBuffer

  bytemove(@displayBuffer, bufferInUsePtr, displayBytes)
}    
{PRI WhiteAll | ledIndex, colorIndex
 
  repeat ledIndex from 0 to DISPLAY_PIXELS - 1
    displayBuffer[(ledIndex * TRI_COLOR) + RED_PORTION] := 255
    displayBuffer[(ledIndex * TRI_COLOR) + GREEN_PORTION] := 255
    displayBuffer[(ledIndex * TRI_COLOR) + BLUE_PORTION] := 255
          
PRI RainbowAngled(colorWidth) | ledIndex, colorIndex[3]

  longfill(@colorIndex, 0, 3)
  repeat
    if ++rainbowTransitionIndex == colorTransitions
      rainbowTransitionIndex := 0
      result := rainbowIndex
      if ++rainbowIndex > VIOLET 'WHITE
        rainbowIndex := RED
      

      'repeat until not lockset(debugLock)
      'Pst.str(string(13, "color = "))
      'Pst.str(GetColorName(rainbowIndex))
      'lockclr(debugLock)
      'Pause(500)
        
      globalColor[RED_PORTION] := blackSetting[(result * TRI_COLOR) + RED_PORTION] * 10
      globalColor[GREEN_PORTION] := blackSetting[(result * TRI_COLOR) + GREEN_PORTION] * 10
      globalColor[BLUE_PORTION] := blackSetting[(result * TRI_COLOR) + BLUE_PORTION] * 10
      colorTransition[RED_PORTION] := ((blackSetting[(rainbowIndex * TRI_COLOR) + {
        }RED_PORTION] * 10) - globalColor[RED_PORTION])  / colorTransitions
      colorTransition[BLUE_PORTION] := ((blackSetting[(rainbowIndex * TRI_COLOR) + {
        }BLUE_PORTION] * 10) - globalColor[BLUE_PORTION]) / colorTransitions
      colorTransition[GREEN_PORTION] := ((blackSetting[(rainbowIndex * TRI_COLOR) + {
        }GREEN_PORTION] * 10) - globalColor[GREEN_PORTION]) / colorTransitions
    else
      globalColor[RED_PORTION] += colorTransition[RED_PORTION]
      globalColor[BLUE_PORTION] += colorTransition[BLUE_PORTION]
      globalColor[GREEN_PORTION] += colorTransition[GREEN_PORTION]
      
    {colorIndex[RED_PORTION] += 32
    if colorIndex[RED_PORTION] > 255
      colorIndex[RED_PORTION] := 0                               
      colorIndex[BLUE_PORTION] += 32
      if colorIndex[BLUE_PORTION] > 255
        colorIndex[BLUE_PORTION] := 0
        colorIndex[GREEN_PORTION] += 32
        if colorIndex[GREEN_PORTION] > 255
          longfill(@colorIndex, 0, 3) }
    bytemove(@displayBuffer + displayWidthBytes, @displayBuffer, displayBytes - displayWidthBytes)
    bytemove(@displayBuffer, @displayBuffer + (colorWidth  * TRI_COLOR), displayWidthBytes - (colorWidth  * TRI_COLOR))    
    repeat ledIndex from 0 to colorWidth - 1
      displayBuffer[displayWidthBytes - (colorWidth  * TRI_COLOR) + (ledIndex * TRI_COLOR) + RED_PORTION] := globalColor[RED_PORTION] / 10
      displayBuffer[displayWidthBytes - (colorWidth  * TRI_COLOR) + (ledIndex * TRI_COLOR) + BLUE_PORTION] := globalColor[BLUE_PORTION] / 10
      displayBuffer[displayWidthBytes - (colorWidth  * TRI_COLOR) + (ledIndex * TRI_COLOR) + GREEN_PORTION] := globalColor[GREEN_PORTION] / 10
    Pause(horizontalScrollDelay) 
  while ledMode == RAINBOW_ANGLED_MODE
     
PUB FillTail(localLeds) | deltaBright, localBrightness

  deltaBright := ((brightness + 1) * 100) / localLeds
  localBrightness := 0
  bytefill(@displayBuffer, 0, displayBytes) 
  repeat result from 0 to localLeds - 1 ' * 3) - 1 step 3
    localBrightness += deltaBright
    displayBuffer[(result * 3) + RED_PORTION] := ((blackSetting[(activeColorIndex * 3) + RED_PORTION] {
    } * localBrightness) / DATA_RESOLUTION) / 100 
    displayBuffer[(result * 3) + GREEN_PORTION] := ((blackSetting[(activeColorIndex * 3) + GREEN_PORTION] {
    } * localBrightness) / DATA_RESOLUTION) / 100
    displayBuffer[(result * 3) + BLUE_PORTION] := ((blackSetting[(activeColorIndex * 3) + BLUE_PORTION] {
    } * localBrightness) / DATA_RESOLUTION) / 100

  DumpBuffer(@displayBuffer, displayBytes, 24)
  repeat until not lockset(debugLock)
  Pst.str(string(13, "deltaBright = "))
  Pst.dec(deltaBright)
  lockclr(debugLock)     
  'repeat  
PUB RotateBuffer(rotationAmount) '| totalToRotate

  if rotationAmount > 0
    bytemove(@tempBuffer, @displayBuffer, rotationAmount * ledType)
    bytemove(@displayBuffer, @displayBuffer + (ledType * rotationAmount), (DISPLAY_PIXELS - rotationAmount) * ledType)
    bytemove(@displayBuffer + (ledType * (DISPLAY_PIXELS - rotationAmount)), @tempBuffer, rotationAmount * ledType)
  else
    bytemove(@tempBuffer, @displayBuffer + (ledType * (DISPLAY_PIXELS - rotationAmount)), rotationAmount * ledType)
    bytemove(@displayBuffer + (ledType * rotationAmount), @displayBuffer, (DISPLAY_PIXELS - rotationAmount) * ledType)
    bytemove(@displayBuffer, @tempBuffer, rotationAmount * ledType)
  {DumpBuffer(@displayBuffer, displayBytes)
  repeat until not lockset(debugLock)
  Pst.str(string(13, "@tempBuffer = "))
  Pst.dec(@tempBuffer)
  Pst.str(string(13, "@displayBuffer = "))
  Pst.dec(@displayBuffer)
  Pst.str(string(13, "@displayBuffer + (ledType * rotationAmount) = "))
  Pst.dec(@displayBuffer + (ledType * rotationAmount))
  Pst.str(string(13, "(DISPLAY_PIXELS - rotationAmount) * ledType = "))
  Pst.dec((DISPLAY_PIXELS - rotationAmount) * ledType)
  Pst.str(string(13, "@displayBuffer + (ledType * (DISPLAY_PIXELS - rotationAmount)) = "))
  Pst.dec(@displayBuffer + (ledType * (DISPLAY_PIXELS - rotationAmount)))
  Pst.str(string(13, "result = "))
  Pst.dec(result)
  lockclr(debugLock)
  Pst.charIn     }
  
PUB RotateTail | localColor, localBrightness, localActiveLeds

  localColor := activeColorIndex
  localBrightness := brightness
  localActiveLeds := activeLeds
  repeat 
    RotateBuffer(1)
    Pause(shortPause)
  while ledMode == DRAGON_MODE and activeColorIndex == localColor and {
  } brightness == localBrightness and activeLeds == localActiveLeds
  
PUB BounceTail | localColor, localBrightness, localActiveLeds, localIndex
' needs a lot of help. full of bugs.

  localColor := activeColorIndex
  localBrightness := brightness
  localActiveLeds := activeLeds
  bytemove(@tempBuffer, @displayBuffer, activeLeds * ledType)
  'repeat localIndex from 0 to activeLeds - 1
  '  altLedBuffer1[localIndex] :=  tempBuffer[(activeLeds - 1) - localIndex]
  DumpBuffer(@displayBuffer, displayBytes, 24)
  Pst.charIn  
  repeat  
    repeat DISPLAY_PIXELS - activeLeds
      RotateBuffer(1)
      Pause(shortPause)
    repeat result from 1 to activeLeds '(activeLeds + 1) / 2
      bytemove(@displayBuffer + (ledType * (DISPLAY_PIXELS - result)), @tempBuffer, (ledType * (activeLeds - result)))
      DumpBuffer(@displayBuffer, displayBytes, 24)
      Pst.charIn  
     ' repeat localIndex from 1 to result
     '   displayBuffer[(DISPLAY_PIXELS * ledType) - localIndex] := altLedBuffer1[result - 1]
     '   Pause(shortPause)
      DumpBuffer(@displayBuffer, displayBytes, 24)
      Pst.charIn    
    repeat DISPLAY_PIXELS - activeLeds
      RotateBuffer(-1)
      Pause(shortPause)
    repeat result from 1 to activeLeds '(activeLeds + 1) / 2
    '  bytemove(@displayBuffer, @altLedBuffer1 + result, (ledType * (activeLeds - result)))
      DumpBuffer(@displayBuffer, displayBytes, 24)
      Pst.charIn  
      repeat localIndex from 0 to result - 1
    '    displayBuffer[localIndex] := altLedBuffer1[localIndex + result]
        Pause(shortPause)
      DumpBuffer(@displayBuffer, displayBytes, 24)
      Pst.charIn    
  while ledMode == TAIL_MODE and activeColorIndex == localColor and {
  } brightness == localBrightness and activeLeds == localActiveLeds
}  
PUB GraphKeyboard(ledSourcePtr) | litLeds, nextLedDistinationPtr, {
                                } nextLedSourcePtr, nextPressTarget

  tempDataFlag := GRAPH_MODE
  litLeds := 0
  'bytefill(@displayBuffer, 0, displayBytes)
  result := horizontalScrollDelay
  horizontalScrollDelay /= 4
  ScrollSpace(displayWidthPixels - 1)
  horizontalScrollDelay := result
  result := cnt 
  repeat
    newPresses := 0
    nextPressTarget := pressesPerLed
    litLeds := 0
    nextLedSourcePtr := ledSourcePtr
    nextLedDistinationPtr := @displayBuffer + displayBytes - TRI_COLOR
    nextLedSourcePtr := ledSourcePtr 
    ScrollDisplay(1) 
    repeat
      if spaceCount        
        if ++newPresses => nextPressTarget
          nextPressTarget += pressesPerLed
          if ++litLeds =< ARRAY_HEIGHT
            bytemove(nextLedDistinationPtr, nextLedSourcePtr, TRI_COLOR)
            nextLedSourcePtr += TRI_COLOR
            nextLedDistinationPtr -= displayWidthBytes
        spaceCount--    
    while cnt - result < horizontalScrollDelay
    result += horizontalScrollDelay
    
  while ledMode == GRAPH_MODE 
   
  tempDataFlag := 0

PUB ScrollDisplay(localSize) | dataToScrollIndex, displayRowIndex, firstByteOfRowPtr, lastOfRowIndex
      
  localSize--
  repeat dataToScrollIndex from 0 to localSize
    repeat displayRowIndex from 0 to DISPLAY_HEIGHT - 1
      firstByteOfRowPtr := @displayBuffer + (displayRowIndex * displayWidthBytes)
      lastOfRowIndex := (displayRowIndex * displayWidthBytes) + {
        } displayWidthBytes - TRI_COLOR
      bytemove(firstByteOfRowPtr, firstByteOfRowPtr + TRI_COLOR, displayWidthBytes - TRI_COLOR)
      bytemove(@displayBuffer + lastOfRowIndex, @background, TRI_COLOR)
       
PUB Pulse | localColor, {localBrightness, localActiveLeds, pulseIndex,} localLightLevel

  localColor := activeColorIndex
  if localColor == RAINBOW
    activeColorIndex := WHITE
  'localBrightness := brightness
  'localActiveLeds := activeLeds

  StartIncrementTimer
  repeat
    repeat localLightLevel from DEFAULT_MIN_BRIGHTNESS to brightness - 1 step DEFAULT_MIN_BRIGHTNESS / 2 
      FillDisplay(activeColorIndex, localLightLevel)
      IncrementTime(horizontalScrollDelay)
      'DumpBuffer(@displayBuffer, displayBytes, 24)    
    repeat localLightLevel from brightness to DEFAULT_MIN_BRIGHTNESS + 1 step DEFAULT_MIN_BRIGHTNESS / 2   
      FillDisplay(activeColorIndex, localLightLevel)
      IncrementTime(horizontalScrollDelay)
      'DumpBuffer(@displayBuffer, displayBytes, 24)      
  while ledMode == PULSE_MODE {and activeColorIndex == localColor and 
   brightness == localBrightness and activeLeds == localActiveLeds   }
  if activeColorIndex == WHITE and localColor == RAINBOW
    activeColorIndex := RAINBOW
{PUB Flash(localColor, localIndex, delay) | waitTime

  'previousBufferInUsePtr := bufferInUsePtr
  delay *= millisecond
  
  repeat result from 0 to displayBytes - 1 step 3
    tempBuffer[result + RED_PORTION] := blackSetting[(localColor * 3) + RED_PORTION]
    tempBuffer[result + GREEN_PORTION] := blackSetting[(localColor * 3) + GREEN_PORTION]
    tempBuffer[result + BLUE_PORTION] := blackSetting[(localColor * 3) + BLUE_PORTION]
  waitTime := cnt 
  repeat localIndex
    'RefreshDisplay
    bytemove(@displayBuffer, @tempbuffer, displayBytes) 
    waitcnt(waitTime += delay)
    bytefill(@displayBuffer, 0, displayBytes)
    waitcnt(waitTime += delay)
  'bufferInUsePtr := previousBufferInUsePtr
  'bytemove(@displayBuffer, bufferInUsePtr, displayBytes) 
  ledMode := previousLedMode
}   
PUB Solid | localColor, previousColor

  localColor := activeColorIndex
  if localColor == RAINBOW
    activeColorIndex := WHITE
  previousColor := activeColorIndex
  
  {repeat until not lockset(debugLock)
  Pst.str(GetColorName(activeColorIndex))
  lockclr(debugLock)    }
  repeat until not lockset(debugLock)
  Debug
  Pst.str(string("localColor := "))
  Pst.Dec(localColor)
        
  lockclr(debugLock)
  outa[(FIRST_ANODE_PIN + 7)..FIRST_ANODE_PIN] := %1111_1111
  dira[(FIRST_ANODE_PIN + 7)..FIRST_ANODE_PIN] := %1111_1111
  FillDisplay(activeColorIndex, brightness)
  repeat while ledMode == SOLID_MODE and activeColorIndex == previousColor
  outa[(FIRST_ANODE_PIN + 7)..FIRST_ANODE_PIN] := 0
  dira[(FIRST_ANODE_PIN + 7)..FIRST_ANODE_PIN] := 0
  if activeColorIndex == WHITE and localColor == RAINBOW and ledMode <> SOLID_MODE
    activeColorIndex := RAINBOW
  {repeat result from 0 to displayBytes - 1 step 3
    displayBuffer[result + RED_PORTION] := blackSetting[(localColor * 3) + RED_PORTION] {
                               } '* (brightness + 1) / DATA_RESOLUTION 
    displayBuffer[result + GREEN_PORTION] := blackSetting[(localColor * 3) + GREEN_PORTION] {
                               } '* (brightness + 1) / DATA_RESOLUTION 
    displayBuffer[result + BLUE_PORTION] := blackSetting[(localColor * 3) + BLUE_PORTION] {
                               } '* (brightness + 1) / DATA_RESOLUTION  }
 ' DumpBuffer(@displayBuffer, displayBytes)
    
{PUB Chase(localColor, ledsToLight, direction) | localMode, waitTime, delay, tailLeds, localIndex

  delay := flashDurationMs * millisecond
  localMode := ledMode
  bytefill(@displayBuffer, 0, displayBytes)
  result := (DISPLAY_PIXELS / ledsToLight) * 3
  
  localIndex := 0
  repeat  
    displayBuffer[localIndex + RED_PORTION] := blackSetting[(localColor * 3) + RED_PORTION]
    displayBuffer[localIndex + GREEN_PORTION] := blackSetting[(localColor * 3) + GREEN_PORTION]
    displayBuffer[localIndex + BLUE_PORTION] := blackSetting[(localColor * 3) + BLUE_PORTION]
    localIndex += result
  while localIndex < displayBytes - 1  
  waitTime := cnt
  
  if direction == COUNTER_CLOCKWISE 
    repeat while ledMode == localMode
      'RefreshDisplay
      waitcnt(waitTime += delay)
      bytemove(@tailLeds, @displayBuffer, 3)
      bytemove(@displayBuffer, @displayBuffer + 3, displayBytes - 3)
      bytemove(@displayBuffer + displayBytes - 3 , @tailLeds, 3)
  else
    repeat while ledMode == localMode
      'RefreshDisplay
      waitcnt(waitTime += delay)
      bytemove(@tailLeds, @displayBuffer + displayBytes - 3, 3)
      bytemove(@displayBuffer + 3, @displayBuffer, displayBytes - 3)
      bytemove(@displayBuffer, @tailLeds, 3)

}        
{PUB CylonLeds | timeInterval
 
  bytefill(@displayBuffer, 0, displayBytes)
  result := activeLeds
  activeLeds := 1
  'Solid(activeColorIndex)
  activeLeds := result
  result := 1
  displayBuffer[RED_PORTION] := blackSetting[(activeColorIndex * TRI_COLOR) + RED_PORTION]
  displayBuffer[GREEN_PORTION] := blackSetting[(activeColorIndex * TRI_COLOR) + GREEN_PORTION]
  displayBuffer[BLUE_PORTION] := blackSetting[(activeColorIndex * TRI_COLOR) + BLUE_PORTION]
  repeat
    repeat DISPLAY_PIXELS - 1
      RotateBuffer(result)      ' check on timing, this is a slow (but easy) way to do this
      Pause(shortPause)
      DumpBuffer(@displayBuffer, displayBytes, 24)  
    result *= -1 
  while ledMode == LARSON_MODE
       
'PUB RainbowLeds | timeInterval

'  repeat while ledMode == BOW_MODE
}
PUB CycleColors | localBrightness, colorIndex, brightnessIndex, localColor[TRI_COLOR], {
                } localCurrentColor[TRI_COLOR], localNextColor[TRI_COLOR], {
                } localIncremental[TRI_COLOR], localTransitions, localDirection

  'localBrightness := brightness
  localTransitions := colorTransitions + 1
  StartIncrementTimer
  localDirection := -1
  repeat
    repeat colorIndex from FIRST_RAINBOW_COLOR to LAST_RAINBOW_COLOR
      GetColors(colorIndex, @localCurrentColor)
      if colorIndex == LAST_RAINBOW_COLOR
        GetColors(FIRST_RAINBOW_COLOR, @localNextColor)
      else
        GetColors(colorIndex + 1, @localNextColor)
      FindIncrementalColors(@localCurrentColor, @localNextColor, @localIncremental, localTransitions)  
      
      repeat result from 0 to localTransitions
        IncrementTime(horizontalScrollDelay)
        IncrementColors(@localColor, @localCurrentColor, @localIncremental, {
      } result)
        FillDisplayPtr(@localColor, brightness)
        if ledMode <> CYCLE_MODE 'or brightness <> localBrightness
          return
    if localTransitions == 0
      localDirection := 1
    elseif localTransitions == colorTransitions + 1
      localDirection := -1
    localTransitions += localDirection   
  while ledMode == CYCLE_MODE 'and brightness == localBrightness

{PUB FillDisplayPtr(colorPtr, brightnessIndex) | ledIndex
' return how far past end of buffer color data was written.
' this vaule should be zero

  AdjustBrightness(colorPtr, @displayBuffer, brightnessIndex)
  result := @displayBuffer + TRI_COLOR
  repeat MAX_ALLOWED_WIDTH_PIXELS - 1
    bytemove(result, @displayBuffer, TRI_COLOR)
    result += TRI_COLOR
  repeat ARRAY_HEIGHT - 1 
    bytemove(result, @displayBuffer, displayWidthBytes) 
    result += displayWidthBytes
  result -= @displayBuffer
}  
PUB FillBufferWithColorPtr(colorPtr, brightnessIndex, bufferPtr, pixels) | pixelsFilled
' returns the location of byte just past end of buffer where the color data was written.
' this vaule should be bufferPtr + (pixels * TRI_COLOR) 

  AdjustBrightness(colorPtr, bufferPtr, brightnessIndex)
  '
  'bytemove(result, bufferPtr, TRI_COLOR)
  result := bufferPtr + TRI_COLOR 
  pixelsFilled := 1
  pixels -= pixelsFilled
  repeat
    if pixelsFilled > pixels
      bytemove(result, bufferPtr, (pixelsFilled - pixels) * TRI_COLOR)
      result += (pixelsFilled - pixels) * TRI_COLOR
      pixelsFilled += pixelsFilled - pixels
      pixels := 0
    else
      bytemove(result, bufferPtr, pixelsFilled * TRI_COLOR)
      pixels -= pixelsFilled
      result += pixelsFilled * TRI_COLOR
      pixelsFilled += pixelsFilled      
  while pixels > 0
    
PUB FillDisplayPtr(colorPtr, brightnessIndex) | ledIndex
' returns the location of byte just past end of buffer where the color data was written.
' this vaule should be @displayBuffer + displayBytes

  result := FillBufferWithColorPtr(colorPtr, brightnessIndex, @displayBuffer, displayBytes / TRI_COLOR) 
   
PUB FillDisplay(colorIndex, brightnessIndex) | localColors[TRI_COLOR]
' return how far past end of buffer color data was written.
' this vaule may not be zero

  GetColors(colorIndex, @localColors) 
  result := FillDisplayPtr(@localColors, brightnessIndex)
  
{PUB FillDisplayPtr(colorPtr, brightnessIndex) | moveSize, tooFar
' return how far past end of buffer color data was written.
' this vaule may not be zero

  AdjustBrightness(colorPtr, @displayBuffer, brightnessIndex) 
  tooFar := @displayBuffer + displayBytes
  moveSize := TRI_COLOR
  result := @displayBuffer
  repeat until not lockset(debugLock)
  Pst.str(string(13, "******** Fill  @displayBuffer = "))
  Pst.Dec(@displayBuffer)
  Pst.ClearEnd
  Pst.str(string(13, "colorPtr = "))
  Pst.Dec(colorPtr)
  Pst.ClearEnd
  Pst.str(string(13, "tooFar = "))
  Pst.Dec(tooFar)
  Pst.ClearEnd
  Pst.str(string(13, "displayBuffer color = "))
  lockclr(debugLock)
  DisplayColorBytes(@displayBuffer)
  repeat
    result += moveSize
    bytemove(result, @displayBuffer, moveSize)
    repeat until not lockset(debugLock)
    Pst.str(string(13, "result = "))
    Pst.Dec(result)
    Pst.ClearEnd
    Pst.str(string(13, "moveSize = "))
    Pst.Dec(moveSize)
    Pst.ClearEnd
    lockclr(debugLock)
    moveSize *= 2
  while result < tooFar
  result -= tooFar
}
PUB Pattern | localBrightness, direction

  localBrightness := brightness
  direction := 1
  
  repeat
    repeat result from 200 to 50 step 10
      \PatternCycle(result, direction)
      if ledMode <> PATTERN_MODE or brightness <> localBrightness
        return
    repeat result from 60 to 190 step 10
      \PatternCycle(result, direction)
      if ledMode <> PATTERN_MODE or brightness <> localBrightness
        return
    direction *= -1
  while ledMode == PATTERN_MODE and brightness == localBrightness

PUB PatternCycle(betweenPatternDelay, direction) | patternPtr
' Fix so any size display will work
  
  if direction > 0
    repeat result from 0 to 11
      patternPtr := @patternD00 + (result * PATTERN_SIZE) 'patternSize)
      if activeArrays <> 2
        ResizePattern(patternPtr)
        bytemove(@displayBuffer, @resizedPattern, displayBytes)  
      else
        bytemove(@displayBuffer, patternPtr, PATTERN_SIZE) 'displayBytes) 'patternSize)     
      {  repeat until not lockset(debugLock)
        Pst.str(string(13, "bytemove("))
        Pst.Dec(@displayBuffer)
        Pst.Char(",")
        Pst.Char(32)
        Pst.Dec(patternPtr)
        Pst.Char(",")
        Pst.Char(32)
        Pst.Dec(PATTERN_SIZE)
        Pst.Char(")")
        Pst.Char(32)
        Pst.ClearEnd
        Pst.str(string(13, "displayBytes = "))
        Pst.Dec(displayBytes)
        Pst.ClearEnd
        Pst.str(string(13, "activeArrays = "))
        Pst.Dec(activeArrays)
        Pst.ClearEnd
        lockclr(debugLock) }
      pause(betweenPatternDelay)
      if ledMode <> PATTERN_MODE
        abort     
            
  else
    'repeat result from 0 to 11
    repeat result from 11 to 0
      patternPtr := @patternD00 + (result * PATTERN_SIZE) 'patternSize)
      if activeArrays <> 2
        ResizePattern(patternPtr)
        bytemove(@displayBuffer, @resizedPattern, displayBytes)  
      else
        bytemove(@displayBuffer, patternPtr, PATTERN_SIZE) 'displayBytes) 'patternSize)     
      pause(betweenPatternDelay)  
      if ledMode <> PATTERN_MODE
        abort
  
PUB ResizePattern(patternPtr) | localIndex, incrementEven, incrementOdd, lastOddIndex, patternPixels

  'secondSetPtr := patternPtr + TRI_COLOR
  result := @resizedPattern
  'tooFarPtr := @resizedPattern + displayBytes
  'if activePattern == 1
  'oddFlag := activeArrays // 2
  incrementOdd := activeArrays / 2
  incrementEven := (activeArrays + 1) / 2 'incrementOdd + 1 'incrementOdd
  incrementEven--
  lastOddIndex := incrementOdd - 1
  patternPixels := PATTERN_SIZE / TRI_COLOR
  {repeat until not lockset(debugLock)
  Pst.str(string(13, "PATTERN_SIZE = "))
  Pst.Dec(PATTERN_SIZE)
  Pst.ClearEnd
  Pst.str(string(13, "displayBytes = "))
  Pst.Dec(displayBytes)
  Pst.ClearEnd
  Pst.str(string(13, "activeArrays = "))
  Pst.Dec(activeArrays)
  Pst.ClearEnd
  Pst.str(string(13, "incrementOdd = "))
  Pst.Dec(incrementOdd)
  Pst.ClearEnd
  Pst.str(string(13, "incrementEven = "))
  Pst.Dec(incrementEven)
  Pst.ClearEnd
  Pst.str(string(13, "too far = "))
  Pst.Dec(result + PATTERN_SIZE)
  Pst.ClearEnd
  lockclr(debugLock) }
  repeat patternPixels
    repeat localIndex from 0 to incrementEven '- 1
      bytemove(result, patternPtr, TRI_COLOR)
      {repeat until not lockset(debugLock)
      Pst.str(string(13, "bytemove("))
      Pst.Dec(result)
      Pst.Char(",")
      Pst.Char(32)
      Pst.Dec(patternPtr)
      Pst.Char(",")
      Pst.Char(32)
      Pst.Dec(TRI_COLOR)
      Pst.Char(")")
      Pst.Char(32)
      Pst.ClearEnd
      Pst.str(string(13, "moved color = "))
      Pst.Dec(displayBytes)
      lockclr(debugLock)  
      DisplayColorBytes(patternPtr) }
      result += TRI_COLOR
    patternPtr += TRI_COLOR  
    if incrementOdd
      repeat localIndex from 0 to lastOddIndex 'incrementOdd - 1
        bytemove(result, patternPtr, TRI_COLOR)
        result += TRI_COLOR
    patternPtr += TRI_COLOR  
  'while result < tooFarPtr
  
{PUB CycleLetters | localCharacter[5]

  localCharacter[0] := 32
  localCharacter[2] := 32
  localCharacter[3] := 32
  localCharacter[4] := 0
  StartIncrementTimer
  repeat
    repeat localCharacter[1] from "A" to "z"
      \LoadText(@localCharacter)
  while ledMode == CYCLE_TEXT_MODE     
}      
PUB ScrollMessage(localPtr, localSize)

  {repeat until not lockset(debugLock)
  Pst.str(string(13, "ScrollMessage Method"))
  Pst.str(string(13, "brightness ="))
  Pst.dec(brightness)
  Pst.str(string(13, "activeColorIndex ="))
  Pst.str(GetActiveColorName)
  Pst.str(string(13, "activeFont ="))
  Pst.str(GetActiveFontName)
  lockclr(debugLock)}
  StartIncrementTimer
  repeat
    \LoadText(localPtr)
  while ledMode == TEXT_MODE     
          
{PUB ScrollRainbowMessage(localPtr, localSize)

  activeColorIndex := RAINBOW
  'rainbowTransitionIndex := colorTransitions - 1 ' so it will rollover to zero in first loop
  StartIncrementTimer
  repeat until not lockset(debugLock)
  Pst.str(string(13, "ScrollRainbowMessage Method"))
  Pst.str(string(13, "brightness ="))
  Pst.dec(brightness)
  Pst.str(string(13, "activeColorIndex ="))
  Pst.str(GetActiveColorName)
  Pst.str(string(13, "activeFont ="))
  Pst.str(GetActiveFontName)
  lockclr(debugLock)
  repeat
    \LoadText(localPtr)
  while ledMode == RAINBOW_TEXT_MODE  
 }
{PUB TextMenu | updateMenuFlag, localCharacter

  updateMenuFlag := 0
  {repeat until not lockset(debugLock)
  Pst.str(@textMenuText)
  if bufferSavedFlag == 0
    Pst.str(@notSavedWarningText)
  else
    Pst.str(@savedText)   
  lockclr(debugLock)  }    
  
  repeat
    repeat until not lockset(debugLock)
    lockclr(debugLock)
    
    localCharacter := Pst.RxCount
    if localCharacter
      repeat until not lockset(debugLock)
      lockclr(debugLock)
      localCharacter := Pst.CharIn
        
      case localCharacter
        "D", "d":
          ledMode := TEXT_MODE
          menuMode := TEXT_MENU
        {"N", "n":
          menuMode := MESSAGE_MENU
        "S", "s":
          SaveMessage
          updateMenuFlag := 1   }
        "R", "r":
          menuMode := MAIN_MENU
        '"C", "c":
        '  ledMode := RAINBOW_TEXT_MODE
          'updateMenuFlag := 1
        {"Y", "y":
          ledMode := CYCLE_TEXT_MODE    }
          'updateMenuFlag := 1
        "X", "x":
          menuMode := MAIN_MENU
        "0":
          activeFont := FREE_DESIGN
        "1":
          activeFont := SIMPLYTRONICS_0508
          ' SIMPLYTRONICS_0816
              
  while menuMode == TEXT_MENU and updateMenuFlag == 0
  
}  
{TEXT_MENU: 
      MESSAGE_MENU: 
      CHOOSE_CONFIRM_MESSAGE:
 }
{PUB EnterText | localCharacter

  repeat until not lockset(debugLock)
  Pst.str(@newTextMenuText)
  lockclr(debugLock)


  Pst.StrInMax(@messageBuffer, Pst#MAXSTR_LENGTH)  '** Can larger strings be entered?
  
  menuMode := CHOOSE_CONFIRM_MESSAGE
  bufferSavedFlag := 0

PUB SaveMessage

  repeat until not lockset(debugLock)
  Pst.str(string(13, Pst#PX, MENU_DISPLAY_X, "Saving message #"))
  Pst.dec(++messagesSavedCount)
  Pst.str(string(13, Pst#PX, MENU_DISPLAY_X, 34))
  Pst.str(@messageBuffer)
  Pst.char(34)
  Pst.char(13)
  lockclr(debugLock)

  messageSize[messagesSavedCount] := strsize(@messageBuffer)
  
  messageLocation[messagesSavedCount] := nextFreeEepromLoc
  
  messageSize[0] := strsize(@messageBuffer)
  Eeprom.FromRam(@messageLocation + (4 * (messagesSavedCount - 1)), @messageLocation + (4 * (messagesSavedCount - 1)) + 3, @messageLocation + (4 * (messagesSavedCount - 1)))
  Eeprom.FromRam(@messageSize + messagesSavedCount - 1, @messageSize + messagesSavedCount {
    } - 1, @messageSize + messagesSavedCount - 1)
  messagesSavedCount := 1
  Eeprom.FromRam(@messageBuffer, @messageBuffer + messageSize[messagesSavedCount] - 1, nextFreeEepromLoc)
  Eeprom.FromRam(@nextFreeEepromLoc, @nextFreeEepromLoc + 3, @nextFreeEepromLoc)
  nextFreeEepromLoc += messageSize[messagesSavedCount]
  bufferSavedFlag := 1
  
  
PUB ConfirmText | localCharacter

  repeat until not lockset(debugLock)
  Pst.str(@confirmTextText)
  Pst.str(string(13, Pst#PX, MENU_DISPLAY_X, 34))
  Pst.str(@messageBuffer)
  Pst.str(string(34, 13, 13, Pst#PX, MENU_DISPLAY_X, "Is this correct? ("))
  Pst.str(string(34, "Y", 34, " or ", 34, "N", 34, ")", 13))
  lockclr(debugLock)

  repeat  
    localCharacter := Pst.RxCount
    if localCharacter
      localCharacter := Pst.CharIn
        
      case localCharacter
        "Y", "y":
          ledMode := UPDATE_TEXT_MODE
          menuMode := TEXT_MENU
          bufferSavedFlag := 0
        "N", "n":
          menuMode := MESSAGE_MENU
        "X", "x":
          menuMode := TEXT_MENU
}                            
PUB Pause(ms) | t

'' Delay program in milliseconds

  if (ms < 1)                                                   ' delay must be > 0
    return
  else
    t := cnt - 1792                                             ' sync with system counter
    repeat ms                                                   ' run delay
      waitcnt(t += MS_001)
    
PUB StartIncrementTimer

  overTimeFlag := 0         
  incrementTimer := cnt
  
PUB IncrementTime(increment)

  result := cnt
  if result - incrementTimer > increment
    overTimeFlag := 1           ' a loop took too long.
    incrementTimer := result
  else
    repeat
      result := cnt
    while result - incrementTimer < increment
    incrementTimer := result
    
PRI SetSpeed(localSpeed)

  ||localSpeed  ' only postive speed for now
  localSpeed--
  result := speedToDelay[localSpeed]
  result *= MS_001 

PRI DisplayActiveArrays

  repeat until not lockset(debugLock) 
  Pst.str(string(Pst#PC, ACTIVE_ARRAYS_DISPLAY_X, ACTIVE_ARRAYS_DISPLAY_Y, {
  } "activeArrays = "))
  Pst.dec(activeArrays)
  Pst.ClearEnd
  lockclr(debugLock)

PRI DisplayResolution

  repeat until not lockset(debugLock) 
  Pst.str(string(Pst#PC, RESOLUTION_DISPLAY_X, RESOLUTION_DISPLAY_Y, {
  } "resolution = "))
  Pst.dec(resolution)
  Pst.str(string("-bit per color"))
  Pst.ClearEnd
  lockclr(debugLock)

PRI DisplaySpeed

  repeat until not lockset(debugLock) 
  Pst.str(string(Pst#PC, SPEED_DISPLAY_X, SPEED_DISPLAY_Y, {
  } "scroll speed = "))
  Pst.dec(scrollSpeed)
  Pst.ClearEnd
  lockclr(debugLock)

PRI DisplayBrightness

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, ACTIVE_BRIGHTNESS_DISPLAY_X, ACTIVE_BRIGHTNESS_DISPLAY_Y, {
  } "brightness = "))
  Pst.dec(brightness)
  Pst.ClearEnd
  lockclr(debugLock)
    
PRI DisplayColor

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, ACTIVE_COLOR_DISPLAY_X, ACTIVE_COLOR_DISPLAY_Y, {
  } "active color = "))    
  Pst.str(GetColorName(activeColorIndex))
  Pst.ClearEnd
  lockclr(debugLock)
    
PRI DisplayActiveNumber

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, ACTIVE_LEDS_DISPLAY_X, ACTIVE_LEDS_DISPLAY_Y, {
  } "number of active LEDs = "))    
  Pst.dec(activeLeds)
  Pst.ClearEnd
  lockclr(debugLock)
    
PRI DisplayMode

  repeat until not lockset(debugLock)
  Pst.str(string(Pst#PC, MODE_DISPLAY_X, MODE_DISPLAY_Y, {
  } "LED mode = "))    
  Pst.str(GetModeName(ledMode))
  Pst.ClearEnd 
  lockclr(debugLock)

PRI DisplayTitle

  repeat until not lockset(debugLock)
  Pst.Clear
  Pst.Position(TITLE_X, TITLE_Y)
  Pst.str(string("8 x 8 RGB LED Array Demo"))
  Pst.ClearEnd
  Pst.Position(TITLE_X, TITLE_Y + 2)
  Pst.str(string("program name of top object = "))
  Pst.str(@programName)
  Pst.ClearEnd
  lockclr(debugLock)

PUB DisplayTempData

  repeat until not lockset(debugLock)
  Pst.Position(TEMP_DISPLAY_X, TEMP_DISPLAY_Y)
  case tempDataFlag
    GRAPH_MODE:
      Pst.str(string("Graphing Spacebar Presses"))
      Pst.ClearEnd 
      Pst.str(string(13, "Scroll speed will change how fast the graph moves."))
      Pst.ClearEnd 
      Pst.str(string(13, "Vertical scale is presently ")) 
      Pst.dec(pressesPerLed)
      Pst.str(string(" keypresses per LED.")) 
      Pst.ClearEnd
      Pst.str(string(13, "Press ", 34, "[", 34, " to decrease keypresses per LED." ))
      Pst.ClearEnd 
      Pst.str(string(13, "Press ", 34, "]", 34, " to increase keypresses per LED." ))
      Pst.ClearEnd  
      Pst.str(string(13, 13, "   Presses so far this period = ")) 
      Pst.dec(newPresses)
      Pst.ClearEnd
      Pst.str(string(13, "spaceCount = "))
      Pst.Dec(spaceCount)
      Pst.ClearEnd
      Pst.str(string(13, "pressesPerLed = "))
      Pst.Dec(pressesPerLed)
      Pst.ClearEnd
  lockclr(debugLock)
  
PRI ClearTempData

  repeat until not lockset(debugLock)
  Pst.Position(TEMP_DISPLAY_X, TEMP_DISPLAY_Y)
  Pst.ClearEnd 
  Pst.ClearBelow
  lockclr(debugLock)
   
PUB DisplayInfo

  repeat until not lockset(debugLock)
  Pst.Clear
  lockclr(debugLock)
  DisplayTitle
  DisplayMode
  DisplayActiveNumber
  DisplayColor
  DisplayBrightness
  DisplaySpeed
  DisplayResolution
  DisplayActiveArrays
  if tempDataFlag
    previousTempDataFlag := tempDataFlag
    DisplayTempData
  elseif previousTempDataFlag
    previousTempDataFlag := tempDataFlag
    ClearTempData
    
{PRI GetActiveColorName

  result := GetColorName(activeColorIndex)
}  
PRI GetActiveFontName

  case activeFont
    FREE_DESIGN:
      result := string("FREE_DESIGN")
    SIMPLYTRONICS_0508:
      result := string("SIMPLYTRONICS_0508")
    'SIMPLYTRONICS_0816:
    '  result := string("SIMPLYTRONICS_0816")
          
PRI GetModeName(localMode)

  case localMode        
    OFF_MODE:
      result := string("OFF_MODE")
    LARSON_MODE:
      result := string("LARSON_MODE")        
    SOLID_MODE:
      result := string("SOLID_MODE")
    DRAGON_MODE:
      result := string("DRAGON_MODE")
    TAIL_MODE:
      result := string("TAIL_MODE")
    ROTATE_MODE:
      result := string("ROTATE_MODE")
    PULSE_MODE:
      result := string("PULSE_MODE")
    BOW_MODE:
      result := string("BOW_MODE")
    PATTERN_MODE:
      result := string("PATTERN_MODE")
    CYCLE_MODE:
      result := string("CYCLE_MODE")
    TEXT_MODE:
      result := string("TEXT_MODE")
    UPDATE_TEXT_MODE:
      result := string("UPDATE_TEXT_MODE")
    WHITE_MODE:
      result := string("WHITE_MOD")
    RAINBOW_ANGLED_MODE:
      result := string("RAINBOW_ANGLED_MODE")
    CYCLE_TEXT_MODE:
      result := string("CYCLE_TEXT_MODE")
    other:
      result := string("other mode")

PRI GetColorName(localColor)

  case localColor
    BLACK:
      result := string("BLACK")
    RED:
      result := string("RED")
    ORANGE:
      result := string("ORANGE")
    YELLOW:
      result := string("YELLOW")
    GREEN:
      result := string("GREEN")
    BLUE:
      result := string("BLUE")
    INDIGO:
      result := string("INDIGO")
    VIOLET:
      result := string("VIOLET")
    WHITE:
      result := string("WHITE")
    RAINBOW:
      result := string("RAINBOW")
    other:
      result := string("other")
      
PUB DumpBuffer(localPtr, localSize, localColumns) | bufferIndex

  repeat until not lockset(debugLock)
  Pst.Position(TITLE_X, BUFFER_DUMP_Y)
  Pst.str(string("displayBuffer buffer dump:", 13))
  repeat bufferIndex from 0 to localSize - 1
    if bufferIndex // localColumns == 0
      Pst.Char(13)
    Pst.Char(32)  
    Pst.Char("$")  
    Pst.hex(byte[localPtr + bufferIndex], 2)
  lockclr(debugLock)

{PRI BuildLongColors

  repeat result from 0 to 9
    backgroundL[result] := background[(result * 3)] << 16 | background[(result * 3) + 1] {
    } << 8 | background[(result * 3) + 2]
}    
{PRI BuildLongColors

  repeat result from 0 to CUSTOM_COLOR
    backgroundL[result] := background[(result * 3) + 2] << 16 | background[(result * 3) + 1] {
    } << 8 | background[result * 3]
    
PRI BuildLongColor(localRed, localGreen, localBlue)

  result := localBlue << 16 | localGreen << 8 | localRed
    
PRI FillThreeBytesFromLongColor(localPtr, longColor)

  repeat result from 0 to 2
    byte[localPtr + result] :=  longColor & $FF
    longColor >>= 8
    
PRI ModifyBrightnessSt(localBrightness) | tempByte[3]

  if localBrightness == DEFAULT_MAX_BRIGHTNESS
    customSettingL := originalCustomSettingL
    return customSettingL
    
  FillThreeBytesFromLongColor(@tempByte, originalCustomSettingL)
  repeat result from 0 to 2
    tempByte[result] := (tempByte[result] * localBrightness) / DEFAULT_MAX_BRIGHTNESS & $FF

  customSettingL := BuildLongColor(tempByte[2], tempByte[1], tempByte[0])
  result := customSettingL
}
PRI GetColors(colorIndex, colorsPtr)

  bytemove(colorsPtr, @blackSetting + (colorIndex * TRI_COLOR), TRI_COLOR)


PRI SetupEyes 

  eyePtr := @eyeNormal
  repeat result from 0 to MAX_EYE_INDEX
    FindEyeSize(result)
    {repeat until not lockset(debugLock)       
    Pst.str(string(13, "eye["))
    Pst.dec(result)
    Pst.str(string("] is "))
    Pst.dec(eyeWidth[result])
    Pst.str(string(" by "))
    Pst.dec(eyeHeight[result])
    Pst.str(string(" pixels "))
    Pst.ClearEnd
    lockclr(debugLock)}
    
{eyeAlignFromOuter       byte 0[EYE_OVAL_HOR + 1], 1[2], 0[2]
eyeAlignFromTop         byte 1, 2, 0, 0, 1, 0[5], 1, 1
eyePupilTop             byte 0[EYE_SLIT_HOR1 + 1]
eyePupilBottom          byte 0[EYE_SLIT_HOR1 + 1] 
eyePupilOuter           byte 0[EYE_SLIT_HOR1 + 1]    
eyePupilInner           byte 0[EYE_SLIT_HOR1 + 1]
eyeWidth                byte 0[EYE_SLIT_HOR1 + 1]
eyeHeight               byte 0[EYE_SLIT_HOR1 + 1]
  EYE_HEIGHT = 8
  EYE_WIDTH = 8
  EYE_PIXELS =
  EYE_BYTES =
  }
PRI FindEyeSize(eyeIndex) | heightIndex, lastHeightIndex, bitIndex, {
  } bitToCheck, rowOfBits, lowestBit, rowOfEyePtr, lastBitIndex, lowestEmptyRow, {
  } emptyFlag
   
  lastHeightIndex := EYE_HEIGHT - 1
  lowestBit := EYE_WIDTH
  lowestEmptyRow := EYE_HEIGHT
  lastBitIndex := lowestBit - 1
  emptyFlag := 0
  rowOfEyePtr := eyePtr + (eyeIndex * EYE_HEIGHT) 
  repeat heightIndex from 0 to lastHeightIndex 
    rowOfBits := byte[rowOfEyePtr++]
    {repeat until not lockset(debugLock)       
    Pst.str(string(13, "row # "))
    Pst.dec(heightIndex)
    Pst.str(string(" rowOfBits = %"))
    Pst.bin(rowOfBits, 8)
    lockclr(debugLock)  }
    if rowOfBits == 0
      'repeat until not lockset(debugLock)
      'Pst.str(string(13, "empty row")) 
      if emptyFlag == 0      
        lowestEmptyRow := heightIndex
        emptyFlag := 1             
       { Pst.str(string(13, "first empty recently "))
        Pst.str(string(13, "lowestEmptyRow = "))
        Pst.dec(lowestEmptyRow)   
      lockclr(debugLock)}
    
    else
      lowestEmptyRow := EYE_HEIGHT
      emptyFlag := 0
    if lastBitIndex == -1
      next
    bitToCheck := 1
    repeat bitIndex from 0 to lastBitIndex 'lastBitIndex '** make generic for other possible widths.
      if bitToCheck & rowOfBits
        lowestBit := bitIndex
        lastBitIndex := lowestBit - 1
        {repeat until not lockset(debugLock)       
        Pst.str(string(13, "lowestBit = "))
        Pst.dec(lowestBit)
        lockclr(debugLock)}  
        quit     
      else

        bitToCheck <<= 1
    if lastBitIndex == -1
      repeat until not lockset(debugLock)
      Pst.str(string(13, "lastBitIndex = "))
      Pst.dec(lastBitIndex)
      lockclr(debugLock)  
      'quit
  result := EYE_WIDTH - lowestBit
  eyeWidth[eyeIndex] := result            
  eyeHeight[eyeIndex] := lowestEmptyRow 'EYE_HEIGHT - lowestEmptyRow
      
PUB BuildEyes(eyeIndex, irisColorPtr, pupilColorPtr, backgroundColorPtr): size | {
  } widthIndex, heightIndex, rowOfIrisBits, {
  } furthestRightBit, mostSigBit, bitToSubtract, {
  } rightEyePtr, leftEyePtr, rowOfEyePtr, bitToCheck, columnIndex,{ 
  } localEyeWidth, columnPtr
'' This method reads the bits making up a character and fills the buffer "fontSpace" with bytes representing
'' the various bits.
              
  'bytefill(@fontSpace, 0, FONT_BYTES_IN_EEPROM)
  FillBufferWithColorPtr(backgroundColorPtr, brightness, @fontSpace, EYES_PIXELS)
  'characterIndex -= LOWEST_ASCII_USED
  furthestRightBit := eyeWidth[eyeIndex]
 
  {repeat until not lockset(debugLock)
  Pst.str(string(13, "characterWidth = "))
  Pst.dec(characterWidth)
  Pst.Str(string(13, "nextColors = "))
  lockclr(debugLock)   }
  'DisplayColorBytes(@nextColors)
  localEyeWidth :=  eyeWidth[eyeIndex]
  if localEyeWidth
    localEyeWidth--
  else
    return  
  {if fontColor == RAINBOW    
    {repeat until not lockset(debugLock)
    Pst.str(string(13, "rainbow colors:"))
    lockclr(debugLock)  }
    columnPtr := @columnColors
    repeat result from 0 to characterWidth
      columnPtr := IncrementColors(columnPtr, @characterColors, @pseudoColorIncrement, {
      } rainbowTransitionIndex)
      
      TransitionRainbow
      'incrementIndex := rainbowTransitionIndex - 1
  else   }
    AdjustBrightness(irisColorPtr, @characterColors, brightness)
    {repeat until not lockset(debugLock)
    Pst.str(string(13, "Non-rainbow color = "))
    lockclr(debugLock)  }
    'DisplayColorBytes(@characterColors)   
    
  

  ' Build font row by row but rainbow colors change by column.
  ' Use array to hold colors in each row.
  rowOfEyePtr := eyePtr + (eyeIndex * EYE_HEIGHT) 
  repeat heightIndex from 0 to EYE_HEIGHT - 1
    {rowOfFontBits := byte[fontPtr[font] + (characterIndex * fontHeight[font]) + {
    } ((fontHeight[font] - 1) - heightIndex)]      }
    rowOfIrisBits := byte[rowOfEyePtr++]
    'if heightIndex or fontColor <> RAINBOW
      {repeat until not lockset(debugLock) 
      Pst.str(string(13, "rowOfFontBits = %"))
      'Pst.dec( rowOfFontBits)
      Pst.bin(rowOfFontBits, 8)
      lockclr(debugLock)  }  
    bitToCheck := 1 << 7
    
    repeat columnIndex from 0 to localEyeWidth
      'if heightIndex == 0 and fontColor == RAINBOW
        {repeat until not lockset(debugLock)
        Pst.str(string(13, "rowOfFontBits = %"))
        Pst.bin(rowOfFontBits, 8)
        Pst.str(string(13, "columnIndex = "))
        Pst.Dec(columnIndex)
        Pst.Str(string(13, "BuildCharacter characterColors = "))
        lockclr(debugLock)  }
        'DisplayColorBytes(@characterColors)
        {repeat until not lockset(debugLock)
        Pst.Str(string(13, "nextColors = "))
        lockclr(debugLock)  }
        'DisplayColorBytes(@nextColors)
      if bitToCheck & rowOfIrisBits  
        rightEyePtr := @fontSpace + (EYES_WIDTH_BYTES * (heightIndex + eyeAlignFromTop[eyeIndex])) + {
        } (TRI_COLOR * (columnIndex + eyeAlignFromOuter[eyeIndex]))
        leftEyePtr := @fontSpace + (EYES_WIDTH_BYTES * (heightIndex + eyeAlignFromTop[eyeIndex])) + {
        }((EYES_WIDTH_BYTES - TRI_COLOR) - (TRI_COLOR * (columnIndex + eyeAlignFromOuter[eyeIndex])))
        {if fontColor == RAINBOW
          columnPtr := @columnColors + (TRI_COLOR * columnIndex)
          bytemove(rightEyePtr, columnPtr, TRI_COLOR)
          {repeat until not lockset(debugLock)
          Pst.str(string(13, "columnIndex = "))
          Pst.Dec(columnIndex)
          Pst.Str(string(", rightEyePtr Colors = "))
          lockclr(debugLock)  }
          'DisplayColorBytes(rightEyePtr)
        
        else }
        bytemove(rightEyePtr, irisColorPtr, TRI_COLOR)  
        bytemove(leftEyePtr, irisColorPtr, TRI_COLOR)
      bitToCheck >>= 1 
 
PUB DisplayEyes | localColors[TRI_COLOR], localColor, localBackground[TRI_COLOR], {
                } localBrightness, localActiveEye, rainbowFlag

  if activeArrays <> 2
    return 0
  else
    result := 1
    
  
  if activeColorIndex == RAINBOW
    rainbowFlag := 1
    activeColorIndex := WHITE
  else
    rainbowFlag := 0
  localColor := activeColorIndex    
  GetColors(activeColorIndex, @localColors)
  localBrightness := brightness
  localActiveEye := activeEye
  AdjustBrightness(@localColors, @localColors, localBrightness)
  AdjustBrightness(@background, @localBackground, localBrightness)
  'localBrightness := brightness
  'localActiveLeds := activeLeds
  BuildEyes(localActiveEye, @localColors, @localBackground, @localBackground)
  bytemove(@displayBuffer, @fontSpace, EYES_BYTES)
  repeat while ledMode == EYES_MODE and activeColorIndex == localColor and {
  } brightness == localBrightness and activeEye == localActiveEye  
  repeat until not lockset(debugLock)
  Debug
  Pst.str(string("ledMode = "))
  Pst.Dec(ledMode)
  Pst.str(string(", EYES_MODE = "))
  Pst.Dec(EYES_MODE)
  Debug
  Pst.str(string("activeColorIndex = "))
  Pst.Dec(activeColorIndex)
  Pst.str(string(", localColor = "))
  Pst.Dec(localColor)
  Debug
  Pst.str(string("activeEye = "))
  Pst.Dec(activeEye)
  Pst.str(string(", localActiveEye = "))
  Pst.Dec(localActiveEye)   
  lockclr(debugLock)

  'if ledMode == EYES_MODE
  '  ledMode := OFF_MODE
  if rainbowFlag and activeColorIndex == WHITE
    activeColorIndex := RAINBOW
    
DAT
' color enumeration tri color LEDs
'  #0, BLACK, RED, ORANGE, YELLOW, GREEN, BLUE, VIOLET, WHITE, CYAN, INDIGO, CUSTOM_COLOR

pBackground             byte 0, 0, 0
background              byte 0, 0, 0
blackSetting            byte 0, 0, 0   
redSetting              byte RED_R, RED_G, RED_B
orangeSetting           byte ORANGE_R, ORANGE_G, ORANGE_B
yellowSetting           byte YELLOW_R, YELLOW_G, YELLOW_B
greenSetting            byte GREEN_R, GREEN_G, GREEN_B
blueSetting             byte BLUE_R, BLUE_G, BLUE_B
violetSetting           byte VIOLET_R, VIOLET_G, VIOLET_B
whiteSetting            byte 255, 255, 255 'WHITE_R, WHITE_G, WHITE_B
cyanSetting             byte CYAN_R, CYAN_G, CYAN_B
indigoSetting           byte INDIGO_R, INDIGO_G, INDIGO_B
customSetting           byte 0[3]
extraBytes              byte 0[3]

{pBackgroundL            long 0
backgroundL             long 0
blackSettingL           long 0[10] 
customSettingL          long 0
originalCustomSettingL  long 0  } 
DAT

displayWidthPixels      long DEFAULT_WIDTH_PIXELS
displayWidthBytes       long DISPLAY_WIDTH_BYTES
displayBytes            long DEFAULT_DISPLAY_BYTES
resolution              long DEFAULT_RESOLUTION_BITS
activeArrays            long DEFAULT_ACTIVE_ARRAYS

DAT

{activeText              byte Pst#PC, MENU_DISPLAY_X, MODE_DISPLAY_Y
                        byte "Led Mode = ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Active Color = ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Active LEDs = ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Active Brightness = ", 13, 0
}                       
mainMenuText            byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                          ' clear to bottom of screen
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        'byte "Mode Menu", 13
                        byte Pst#PX, MENU_DISPLAY_X, "   Select a Mode.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "S) Stop / Off (all LEDs off)    "', 13
                       { byte Pst#PX, MENU_DISPLAY_X, "L) Larson Scanner (cylon)", 13 }
                        'byte Pst#PX, MENU_DISPLAY_X, "S) Solid (all LEDs same color and brightness)", 13
                        {byte Pst#PX, MENU_DISPLAY_X, "D) Dragon Tail (muliple LEDs with diminishing brightness, "
                        byte "rotates through buffer)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "T) Dragon Tail (muliple LEDs with diminishing brightness, "
                        byte "bounces off buffer ends)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "R) Rotating (buffer rotates)", 13 }
                        byte {Pst#PX, MENU_DISPLAY_X,} "P) Pulse (buffer pulses)", Pst#CE, 13 
                        'byte Pst#PX, MENU_DISPLAY_X, "B) Rainbow (fill buffer with repeating rainbow pattern)", 13, 0
                        byte Pst#PX, MENU_DISPLAY_X, "A) Cycling Pattern              "', 13  
                        byte {Pst#PX, MENU_DISPLAY_X,} "L) Cycling Colors", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "T) Scroll Text                  "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "X) Display Rainbow Text", Pst#CE, 13', 0
                        byte Pst#PX, MENU_DISPLAY_X, "I) Graph Spacebar", Pst#CE, 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "   Or Select a Color.", Pst#CE, 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "R) Red      "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "O) Orange", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "Y) Yellow   "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "G) Green", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "B) Blue     "', 13
                        'byte Pst#PX, MENU_DISPLAY_X, "I) Indigo (sort of)", 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "V) Violet", Pst#CE, 13 ' (really purple)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "W) White", Pst#CE, 13, 13
                        'byte Pst#PX, MENU_DISPLAY_X, "X) Rainbow Colors", 13, 13 '0
                        byte Pst#PX, MENU_DISPLAY_X, "   Eyes", Pst#CE, 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "@  Normal Eyes                  "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "^  Crossed Eyes", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "(  Happy Eyes                   "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} ")  Sad Eyes", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "!  Surprise Eyes                "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "#  Fear Eyes", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "{  Vertical Oval Eyes           "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "}  Horizontal Oval Eyes", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "|  Vertical Slit Eyes           "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "_  Horizontal Slit Eyes", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "[  Vertical Narrow Slit Eyes    "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "]  Horizontal Narrow Slit Eyes", Pst#CE, 13, 13
                                                     '         1         2         3
                                                     '12345678901234567890123456789012
                        byte Pst#PX, MENU_DISPLAY_X, "   Other Actions", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "+) Small Brightness Increase    "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "*) Large Brightness Increase", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "-) Small Brightness Decrease    "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "/) Large Brightness Decrease", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "6) Small Scroll Speed Increase  "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "8) Large Scroll Speed Increase", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "4) Small Scroll Speed Decrease  "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "2) Large Scroll Speed Decrease", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "0) ", 34, "Free Design", 34, " Font           "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "1) ", 34, "SimplyTronics", 34, " 5 x 8 Font", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "3) Decrease Number of Arrays    "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "5) Increase Number of Arrays", Pst#CE, 13
                        byte Pst#PX, MENU_DISPLAY_X, "7) Decrease Resolution          "', 13
                        byte {Pst#PX, MENU_DISPLAY_X,} "9) Increase Resolution", Pst#CE, 13, 0

                         
'modifyMenu              byte 13, Pst#PX, MENU_DISPLAY_X, "You may modify the current LEDs with following "
'                        byte "commands", 13, 13, 0
'modifyColor             byte Pst#PX, MENU_DISPLAY_X, "C) Color", 13, 0
'modifyNumber            byte Pst#PX, MENU_DISPLAY_X, "N) Number (change the number of LEDs used in effect)", 13, 0
{modifyBrightness        byte Pst#PX, MENU_DISPLAY_X, "Use ", 34, "+", 34, " or ", 34, "-", 34, " to change the "
                        byte "brightess", 13, 0
modifyFont              byte Pst#PX, MENU_DISPLAY_X, "Enter ", 34, "0", 34, " or ", 34, "1", 34, " to change the "
                        byte "font", 13, 0
                                                                                                                                                     
                        'byte Pst#PC, MENU_DISPLAY_X, BRIGHTNESS_DISPLAY_Y
                        'byte "brightness = ", 0
                        
colorMenuText           byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "Color Menu", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please select a color.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "R) Red", 13
                        byte Pst#PX, MENU_DISPLAY_X, "O) Orange", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Y) Yellow", 13
                        byte Pst#PX, MENU_DISPLAY_X, "G) Green", 13
                        byte Pst#PX, MENU_DISPLAY_X, "B) Blue", 13
                        'byte Pst#PX, MENU_DISPLAY_X, "I) Indigo (sort of)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "V) Violet (really purple)", 13
                        byte Pst#PX, MENU_DISPLAY_X, "W) White", 13
                        byte Pst#PX, MENU_DISPLAY_X, "X) Rainbow Colors", 13, 0       }
                        
{brightnessMenuText      byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte "Brightness Menu", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "Press ", 34, "+", 34
                        byte " to increase brightness", 13
                        byte "Press ", 34, "-", 34, " to decrease brightness"
                        byte Pst#PC, MENU_DISPLAY_X, BRIGHTNESS_DISPLAY_Y
                        byte "brightness = ", 0      

numberMenuText          byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte "Enter a Number", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please enter a number between ", 0

DAT

textMenuText            byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "Text Menu", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please select text option.", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "This menu is under construction.", 13
                        byte Pst#PX, MENU_DISPLAY_X, "Exit only option.", 13
                        byte Pst#PX, MENU_DISPLAY_X, "The option to edit displayed", 13
                        byte Pst#PX, MENU_DISPLAY_X, "text will be a future feature.", 13
                        'byte Pst#PX, MENU_DISPLAY_X, "D) Display current buffer.", 13
                        'byte Pst#PX, MENU_DISPLAY_X, "N) Enter new text to buffer.", 13
                        'byte Pst#PX, MENU_DISPLAY_X, "S) Save current buffer to EEPROM", 13
                        'byte Pst#PX, MENU_DISPLAY_X, "R) Retreive text from EEPROM", 13
                        byte Pst#PX, MENU_DISPLAY_X, "X) Exit text menu", 13, 0

newTextMenuText         byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "Enter Text", 13, 13
                        byte Pst#PX, MENU_DISPLAY_X, "Please enter text to display", 13
                        byte Pst#PX, MENU_DISPLAY_X, "followed by the ", 34, "Enter", 34, " key.", 13, 13, 0

confirmTextText         byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y, Pst#CB
                        byte Pst#PC, MENU_DISPLAY_X, MENU_DISPLAY_Y
                        byte Pst#PX, MENU_DISPLAY_X, "You entered", 13, 0
                       
notSavedWarningText     byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **           Warning!             **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   The text in the message      **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   buffer has not been saved.   **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13, 0
                           
savedText               byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   The text in the message      **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   buffer has been saved to     **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **   EEPROM.                      **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  **                                **    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13
                        byte Pst#PX, MENU_DISPLAY_X, "  ************************************    ", 13, 0
}
DAT freeDesign032       byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign033           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
              
freeDesign034           byte %10100000
                        byte %10100000
                        byte %10100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                         
freeDesign035           byte %01010000
                        byte %11111000
                        byte %01010000
                        byte %11111000
                        byte %01010000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign036           byte %01000000
                        byte %01110000
                        byte %11000000
                        byte %11100000
                        byte %01110000
                        byte %00110000
                        byte %11100000
                        byte %01000000
              
freeDesign037           byte %01111100
                        byte %10100100
                        byte %10100100
                        byte %01001000
                        byte %00010010
                        byte %00100101
                        byte %00100101
                        byte %00100010
              
freeDesign038           byte %00111100
                        byte %01100100
                        byte %01100000
                        byte %00110000
                        byte %01000110
                        byte %11001100
                        byte %11001100
                        byte %01110110
              
freeDesign039           byte %10000000
                        byte %10000000
                        byte %10000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign040           byte %00100000
                        byte %01000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %01000000
                        byte %00100000

freeDesign041           byte %10000000
                        byte %01000000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01000000
                        byte %10000000
                         
freeDesign042           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %10101000
                        byte %01110000
                        byte %10101000
                        byte %00100000
                        byte %00000000

freeDesign043           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %00100000
                        byte %11111000
                        byte %00100000
                        byte %00100000
                        byte %00000000

freeDesign044           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %01000000
                        byte %10000000
              
freeDesign045           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
              
freeDesign046           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
              
freeDesign047           byte %00010000
                        byte %00010000
                        byte %00100000
                        byte %00100000
                        byte %01000000
                        byte %01000000
                        byte %10000000
                        byte %10000000
              
freeDesign048           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11101100
                        byte %11011100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign049           byte %01100000
                        byte %11100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
              
freeDesign050           byte %01110000
                        byte %10011000
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %11111000
              
freeDesign051           byte %01110000
                        byte %10011000
                        byte %00011000
                        byte %01110000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %11110000
              
freeDesign052           byte %00011000
                        byte %00011000
                        byte %01011000
                        byte %01011000
                        byte %10011000
                        byte %11111100
                        byte %00011000
                        byte %00011000
              
freeDesign053           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %11110000
              
freeDesign054           byte %00111000
                        byte %01000000
                        byte %11000000
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign055           byte %11111100
                        byte %00001100
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
              
freeDesign056           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign057           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %00011000
                        byte %01110000
              
freeDesign058           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000

freeDesign059           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %11000000
                        byte %00000000
                        byte %11000000
                        byte %01000000
                        byte %10000000
                         
freeDesign060           byte %00000000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00000000
              
freeDesign061           byte %00000000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %11100000
                        byte %00000000
                        byte %00000000
                        byte %00000000
              
freeDesign062           byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %11000000
                        byte %00000000
              
freeDesign063           byte %11111000
                        byte %11001100
                        byte %00001100
                        byte %00011000
                        byte %00110000
                        byte %00100000
                        byte %00000000
                        byte %00110000
              
freeDesign064           byte %00111110
                        byte %01000001
                        byte %10011101
                        byte %10100101
                        byte %10100101
                        byte %10111111
                        byte %01000000
                        byte %00111110
              
freeDesign065           byte %00110000
                        byte %00110000
                        byte %00111000
                        byte %01011000
                        byte %01011000
                        byte %11111100
                        byte %10001100
                        byte %10001100
              
freeDesign066           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
              
freeDesign067           byte %01111000
                        byte %11001000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11001000
                        byte %01110000
              
freeDesign068           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
              
freeDesign069           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11111000
                         
freeDesign070           byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
              
freeDesign071           byte %01111100
                        byte %11000100
                        byte %11000000
                        byte %11000000
                        byte %11011100
                        byte %11001100
                        byte %11001100
                        byte %01110100
                         
freeDesign072           byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
              
freeDesign073           byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign074           byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %00011000
                        byte %10011000
                        byte %01110000
              
freeDesign075           byte %11000100
                        byte %11001000
                        byte %11010000
                        byte %11110000
                        byte %11011000
                        byte %11011000
                        byte %11001100
                        byte %11001100
              
freeDesign076           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11111000
                         
freeDesign077           byte %11000110
                        byte %11000110
                        byte %11101110
                        byte %11101110
                        byte %10110110
                        byte %10110110
                        byte %10000110
                        byte %10000110
              
freeDesign078           byte %11001000 
                        byte %11001000
                        byte %11101000
                        byte %11101000
                        byte %10111000
                        byte %10111000
                        byte %10011000
                        byte %10011000
              
freeDesign079           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign080           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                         
freeDesign081           byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00001110
                         
freeDesign082           byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
              
freeDesign083           byte %01111000
                        byte %11001000
                        byte %11100000
                        byte %01110000
                        byte %00111000
                        byte %00011000
                        byte %10011000
                        byte %11110000
              
freeDesign084           byte %11111100
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign085           byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
              
freeDesign086           byte %11000100
                        byte %11000100
                        byte %01101000
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign087           byte %11000001
                        byte %11000001
                        byte %01101001
                        byte %01101101
                        byte %01101101
                        byte %00110011
                        byte %00110011
                        byte %00110011
              
freeDesign088           byte %11001000
                        byte %11001000
                        byte %01110000
                        byte %01100000
                        byte %00110000
                        byte %01110000
                        byte %10011000
                        byte %10011000
              
freeDesign089           byte %11000100
                        byte %11000100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
              
freeDesign090           byte %11111000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11111000
              
freeDesign091           byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11110000

freeDesign092           byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %01100000
                        byte %00110000
                        byte %00110000
                        byte %00011000
                        byte %00000000

freeDesign093           byte %11110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %00110000
                        byte %11110000
                         
freeDesign094           byte %00000000
                        byte %00000000
                        byte %00100000
                        byte %01010000
                        byte %10001000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign095           byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %11111111
                         
freeDesign096           byte %00000000
                        byte %00000000
                        byte %11000000
                        byte %01100000
                        byte %00110000
                        byte %00000000
                        byte %00000000
                        byte %00000000

freeDesign097           byte %00000000
                        byte %01111000
                        byte %00001100
                        byte %01111100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00000000
                         
freeDesign098           byte %11000000
                        byte %11000000
                        byte %11111000
                        byte %11001100 
                        byte %11001100 
                        byte %11001100
                        byte %11111000
                        byte %00000000

freeDesign099           byte %00000000
                        byte %01111000
                        byte %11001000
                        byte %11000000
                        byte %11000000
                        byte %11001000
                        byte %01110000
                        byte %00000000

freeDesign100           byte %00001100
                        byte %00001100
                        byte %01111100
                        byte %11001100 
                        byte %11001100 
                        byte %11001100 
                        byte %01111100
                        byte %00000000

freeDesign101           byte %00000000
                        byte %01111000
                        byte %11001100
                        byte %11011000
                        byte %11100000
                        byte %11000100
                        byte %01111000
                        byte %00000000
              
freeDesign102           byte %00111000
                        byte %01100000
                        byte %11110000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %00000000
                         
freeDesign103           byte %00000000
                        byte %11111110
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %01111000
                         
freeDesign104           byte %11000000
                        byte %11000000
                        byte %11011000
                        byte %11101100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %00000000

freeDesign105           byte %11000000 
                        byte %00000000
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000
                        byte %00000000

freeDesign106           byte %01100000 
                        byte %00000000
                        byte %01100000 
                        byte %01100000 
                        byte %01100000 
                        byte %01100000
                        byte %01100000
                        byte %11000000

freeDesign107           byte %11000000 
                        byte %11000100 
                        byte %11001000 
                        byte %11010000 
                        byte %11110000 
                        byte %11011000 
                        byte %11001100
                        byte %00000000

freeDesign108           byte %11000000 
                        byte %11000000
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000 
                        byte %11000000
                        byte %00000000

freeDesign109           byte %00000000
                        byte %11010010
                        byte %11111111
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %00000000

freeDesign110           byte %00000000
                        byte %11011000
                        byte %11101100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %00000000

freeDesign111           byte %00000000
                        byte %01111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00000000

freeDesign112           byte %00000000
                        byte %11111000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11111000
                        byte %11000000
                        byte %11000000
                         
freeDesign113           byte %00000000
                        byte %01111100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111100
                        byte %00001100
                        byte %00001100
              
freeDesign114           byte %00000000
                        byte %11010000
                        byte %11110000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %00000000

freeDesign115           byte %00000000
                        byte %01110000
                        byte %11000000
                        byte %11100000
                        byte %01110000
                        byte %00110000
                        byte %11100000
                        byte %00000000

freeDesign116           byte %01100000
                        byte %01100000
                        byte %11110000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
                        byte %01100000
              
freeDesign117           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %11001100
                        byte %01111000
                        byte %00000000
                         
freeDesign118           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00110000
                        byte %00000000

freeDesign119           byte %00000000
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %11011011
                        byte %01101100
                        byte %01101100
                        byte %00000000
              
freeDesign120           byte %00000000
                        byte %11001100
                        byte %11101000
                        byte %01110000
                        byte %00111000
                        byte %01011100
                        byte %11001100
                        byte %00000000

freeDesign121           byte %00000000
                        byte %11001100
                        byte %11001100
                        byte %01101000
                        byte %01101000
                        byte %00110000
                        byte %00010000
                        byte %01110000
              
freeDesign122           byte %00000000
                        byte %11110000
                        byte %00110000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11110000
                        byte %00000000
              
freeDesign123           byte %00111000
                        byte %01100000
                        byte %01100000
                        byte %11000000
                        byte %11000000
                        byte %01100000
                        byte %01100000
                        byte %00111000
                         
freeDesign124           byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
                        byte %11000000
              
freeDesign125           byte %11100000
                        byte %00110000
                        byte %00110000
                        byte %00011000
                        byte %00011000
                        byte %00110000
                        byte %00110000
                        byte %11100000
              
freeDesign126           byte %00000000
                        byte %00000000
                        byte %01110000
                        byte %10011001
                        byte %00001110
                        byte %00000000
                        byte %00000000
                        byte %00000000

DAT
'--------------------------------- [ ASCII ]--------------------------------------
'----------------------------------[  5x8  ]--------------------------------------
DAT ASCII_0508_032 byte    $00,$00,$00,$00,$00,$00,$00,$00    ' - -           
ASCII_0508_033 byte        $20,$20,$20,$20,$20,$00,$20,$00    ' -!-           
ASCII_0508_034 byte        $50,$50,$50,$00,$00,$00,$00,$00    ' -"-           
ASCII_0508_035 byte        $50,$50,$F8,$50,$F8,$50,$50,$00    ' -#-           
ASCII_0508_036 byte        $20,$78,$C0,$70,$28,$F0,$20,$00    ' -$-           
ASCII_0508_037 byte        $C0,$C8,$10,$20,$40,$98,$18,$00    ' -%-           
ASCII_0508_038 byte        $40,$A0,$A0,$40,$A8,$90,$68,$00    ' -&-           
ASCII_0508_039 byte        $30,$20,$40,$00,$00,$00,$00,$00    ' -'-           
ASCII_0508_040 byte        $10,$20,$40,$40,$40,$20,$10,$00    ' -(-           
ASCII_0508_041 byte        $40,$20,$10,$10,$10,$20,$40,$00    ' -)-           
ASCII_0508_042 byte        $20,$A8,$70,$20,$70,$A8,$20,$00    ' -*-           
ASCII_0508_043 byte        $20,$20,$20,$F8,$20,$20,$20,$00    ' -+-           
ASCII_0508_044 byte        $00,$00,$00,$00,$60,$40,$80,$00    ' -,-           
ASCII_0508_045 byte        $00,$00,$00,$F8,$00,$00,$00,$00    ' ---           
ASCII_0508_046 byte        $00,$00,$00,$00,$00,$60,$60,$00    ' -.-           
ASCII_0508_047 byte        $00,$08,$10,$20,$40,$80,$00,$00    ' -/-           
ASCII_0508_048 byte        $70,$88,$98,$A8,$C8,$88,$70,$00    ' -0-           
ASCII_0508_049 byte        $20,$60,$20,$20,$20,$20,$70,$00    ' -1-           
ASCII_0508_050 byte        $70,$88,$08,$30,$40,$80,$F8,$00    ' -2-           
ASCII_0508_051 byte        $F8,$08,$10,$30,$08,$88,$70,$00    ' -3-           
ASCII_0508_052 byte        $10,$30,$50,$90,$F8,$10,$10,$00    ' -4-           
ASCII_0508_053 byte        $F8,$80,$F0,$08,$08,$88,$70,$00    ' -5-           
ASCII_0508_054 byte        $38,$40,$80,$F0,$88,$88,$70,$00    ' -6-           
ASCII_0508_055 byte        $F8,$08,$10,$20,$40,$40,$40,$00    ' -7-           
ASCII_0508_056 byte        $70,$88,$88,$70,$88,$88,$70,$00    ' -8-           
ASCII_0508_057 byte        $70,$88,$88,$78,$08,$10,$E0,$00    ' -9-           
ASCII_0508_058 byte        $00,$60,$60,$00,$60,$60,$00,$00    ' -:-           
ASCII_0508_059 byte        $00,$60,$60,$00,$60,$60,$80,$00    ' -;-           
ASCII_0508_060 byte        $10,$20,$40,$80,$40,$20,$10,$00    ' -<-           
ASCII_0508_061 byte        $00,$00,$F8,$00,$F8,$00,$00,$00    ' -=-           
ASCII_0508_062 byte        $40,$20,$10,$08,$10,$20,$40,$00    ' ->-           
ASCII_0508_063 byte        $70,$88,$10,$20,$20,$00,$20,$00    ' -?-           
ASCII_0508_064 byte        $70,$88,$B8,$A8,$B8,$80,$78,$00    ' -@-           
ASCII_0508_065 byte        $20,$50,$88,$88,$F8,$88,$88,$00    ' -A-           
ASCII_0508_066 byte        $F0,$88,$88,$F0,$88,$88,$F0,$00    ' -B-           
ASCII_0508_067 byte        $70,$88,$80,$80,$80,$88,$70,$00    ' -C-           
ASCII_0508_068 byte        $F0,$88,$88,$88,$88,$88,$F0,$00    ' -D-           
ASCII_0508_069 byte        $F8,$80,$80,$F0,$80,$80,$F8,$00    ' -E-           
ASCII_0508_070 byte        $F8,$80,$80,$F0,$80,$80,$80,$00    ' -F-           
ASCII_0508_071 byte        $70,$88,$80,$80,$B8,$88,$78,$00    ' -G-           
ASCII_0508_072 byte        $88,$88,$88,$F8,$88,$88,$88,$00    ' -H-           
ASCII_0508_073 byte        $70,$20,$20,$20,$20,$20,$70,$00    ' -I-           
ASCII_0508_074 byte        $38,$10,$10,$10,$10,$90,$60,$00    ' -J-           
ASCII_0508_075 byte        $88,$90,$A0,$C0,$A0,$90,$88,$00    ' -K-           
ASCII_0508_076 byte        $80,$80,$80,$80,$80,$80,$F8,$00    ' -L-           
ASCII_0508_077 byte        $88,$D8,$A8,$A8,$88,$88,$88,$00    ' -M-           
ASCII_0508_078 byte        $88,$88,$C8,$A8,$98,$88,$88,$00    ' -N-           
ASCII_0508_079 byte        $70,$88,$88,$88,$88,$88,$70,$00    ' -O-           
ASCII_0508_080 byte        $F0,$88,$88,$F0,$80,$80,$80,$00    ' -P-           
ASCII_0508_081 byte        $70,$88,$88,$88,$A8,$90,$68,$00    ' -Q-           
ASCII_0508_082 byte        $F0,$88,$88,$F0,$A0,$90,$88,$00    ' -R-           
ASCII_0508_083 byte        $70,$88,$80,$70,$08,$88,$70,$00    ' -S-           
ASCII_0508_084 byte        $F8,$20,$20,$20,$20,$20,$20,$00    ' -T-           
ASCII_0508_085 byte        $88,$88,$88,$88,$88,$88,$70,$00    ' -U-           
ASCII_0508_086 byte        $88,$88,$88,$88,$88,$50,$20,$00    ' -V-           
ASCII_0508_087 byte        $88,$88,$88,$A8,$A8,$D8,$88,$00    ' -W-           
ASCII_0508_088 byte        $88,$88,$50,$20,$50,$88,$88,$00    ' -X-           
ASCII_0508_089 byte        $88,$88,$50,$20,$20,$20,$20,$00    ' -Y-           
ASCII_0508_090 byte        $F8,$08,$10,$20,$40,$80,$F8,$00    ' -Z-           
ASCII_0508_091 byte        $F0,$C0,$C0,$C0,$C0,$C0,$F0,$00    ' -[-           
ASCII_0508_092 byte        $00,$80,$40,$20,$10,$08,$00,$00    ' -\-           
ASCII_0508_093 byte        $78,$18,$18,$18,$18,$18,$78,$00    ' -]-           
ASCII_0508_094 byte        $20,$70,$A8,$20,$20,$20,$20,$00    ' -^-           
ASCII_0508_095 byte        $00,$20,$40,$F8,$40,$20,$00,$00    ' -_-           
ASCII_0508_096 byte        $20,$10,$08,$00,$00,$00,$00,$00    ' -`-           
ASCII_0508_097 byte        $00,$00,$E0,$10,$70,$90,$68,$00    ' -a-           
ASCII_0508_098 byte        $80,$80,$B0,$C8,$88,$C8,$B0,$00    ' -b-           
ASCII_0508_099 byte        $00,$00,$70,$88,$80,$80,$70,$00    ' -c-           
ASCII_0508_100 byte        $08,$08,$68,$98,$88,$98,$68,$00    ' -d-           
ASCII_0508_101 byte        $00,$00,$70,$88,$F0,$80,$70,$00    ' -e-           
ASCII_0508_102 byte        $30,$48,$40,$F0,$40,$40,$40,$00    ' -f-           
ASCII_0508_103 byte        $00,$00,$70,$88,$88,$78,$08,$F0    ' -g-           
ASCII_0508_104 byte        $80,$80,$B0,$C8,$88,$88,$88,$00    ' -h-           
ASCII_0508_105 byte        $20,$00,$00,$20,$20,$20,$20,$00    ' -i-           
ASCII_0508_106 byte        $10,$00,$00,$30,$10,$10,$10,$60    ' -j-           
ASCII_0508_107 byte        $80,$80,$90,$A0,$C0,$A0,$98,$00    ' -k-           
ASCII_0508_108 byte        $60,$20,$20,$20,$20,$20,$70,$00    ' -l-           
ASCII_0508_109 byte        $00,$00,$50,$A8,$A8,$A8,$A8,$00    ' -m-           
ASCII_0508_110 byte        $00,$00,$B0,$48,$48,$48,$48,$00    ' -n-           
ASCII_0508_111 byte        $00,$00,$70,$88,$88,$88,$70,$00    ' -o-           
ASCII_0508_112 byte        $00,$00,$F0,$88,$88,$F0,$80,$80    ' -p-           
ASCII_0508_113 byte        $00,$00,$78,$88,$88,$78,$08,$08    ' -q-           
ASCII_0508_114 byte        $00,$00,$B0,$48,$40,$40,$40,$00    ' -r-           
ASCII_0508_115 byte        $00,$00,$78,$80,$70,$08,$F0,$00    ' -s-           
ASCII_0508_116 byte        $40,$40,$F8,$40,$40,$48,$30,$00    ' -t-           
ASCII_0508_117 byte        $00,$00,$90,$90,$90,$90,$68,$00    ' -u-           
ASCII_0508_118 byte        $00,$00,$88,$88,$88,$50,$20,$00    ' -v-           
ASCII_0508_119 byte        $00,$00,$A8,$A8,$A8,$A8,$50,$00    ' -w-           
ASCII_0508_120 byte        $00,$00,$88,$50,$20,$50,$88,$00    ' -x-           
ASCII_0508_121 byte        $00,$00,$88,$88,$98,$68,$08,$F0    ' -y-           
ASCII_0508_122 byte        $00,$00,$F8,$10,$20,$40,$F8,$00    ' -z-           
ASCII_0508_123 byte        $20,$40,$40,$80,$40,$40,$20,$00    ' -{-           
ASCII_0508_124 byte        $20,$20,$20,$00,$20,$20,$20,$00    ' -|-           
ASCII_0508_125 byte        $20,$10,$10,$08,$10,$10,$20,$00    ' -}-           
ASCII_0508_126 byte        $00,$00,$40,$A8,$10,$00,$00,$00    ' -~-           
ASCII_0508_127 byte        $A8,$50,$A8,$50,$A8,$50,$A8,$00    ' --


'--------------------------------- [ ASCII ]---------------------------------------
'----------------------------------[  8x16  ]--------------------------------------
{
DAT ASCII_0816_032 byte    $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00    ' - -
ASCII_0816_033 byte        $00,$00,$18,$3C,$3C,$3C,$18,$18,$18,$00,$18,$18,$00,$00,$00,$00    ' -!- 
ASCII_0816_034 byte        $00,$66,$66,$66,$24,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00    ' -"- 
ASCII_0816_035 byte        $00,$00,$00,$6C,$6C,$FE,$6C,$6C,$6C,$FE,$6C,$6C,$00,$00,$00,$00    ' -#-
ASCII_0816_036 byte        $18,$18,$7C,$C6,$C2,$C0,$7C,$06,$86,$C6,$7C,$18,$18,$00,$00,$00    ' -$- 
ASCII_0816_037 byte        $00,$00,$00,$00,$C2,$C6,$0C,$18,$30,$60,$C6,$86,$00,$00,$00,$00    ' -%-
ASCII_0816_038 byte        $00,$00,$38,$6C,$6C,$38,$76,$DC,$CC,$CC,$CC,$76,$00,$00,$00,$00    ' -&-
ASCII_0816_039 byte        $00,$30,$30,$30,$60,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00    ' -'-
ASCII_0816_040 byte        $00,$00,$0C,$18,$30,$30,$30,$30,$30,$30,$18,$0C,$00,$00,$00,$00    ' -(-
ASCII_0816_041 byte        $00,$00,$30,$18,$0C,$0C,$0C,$0C,$0C,$0C,$18,$30,$00,$00,$00,$00    ' -)-
ASCII_0816_042 byte        $00,$00,$00,$00,$00,$66,$3C,$FF,$3C,$66,$00,$00,$00,$00,$00,$00    ' -*-
ASCII_0816_043 byte        $00,$00,$00,$00,$00,$18,$18,$7E,$18,$18,$00,$00,$00,$00,$00,$00    ' -+-
ASCII_0816_044 byte        $00,$00,$00,$00,$00,$00,$00,$00,$00,$18,$18,$18,$30,$00,$00,$00    ' -,-
ASCII_0816_045 byte        $00,$00,$00,$00,$00,$00,$00,$FE,$00,$00,$00,$00,$00,$00,$00,$00    ' ---
ASCII_0816_046 byte        $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$18,$18,$00,$00,$00,$00    ' -.-
ASCII_0816_047 byte        $00,$00,$00,$00,$02,$06,$0C,$18,$30,$60,$C0,$80,$00,$00,$00,$00    ' -/-
ASCII_0816_048 byte        $00,$00,$7C,$C6,$C6,$CE,$D6,$D6,$E6,$C6,$C6,$7C,$00,$00,$00,$00    ' -0-
ASCII_0816_049 byte        $00,$00,$18,$38,$78,$18,$18,$18,$18,$18,$18,$7E,$00,$00,$00,$00    ' -1-
ASCII_0816_050 byte        $00,$00,$7C,$C6,$06,$0C,$18,$30,$60,$C0,$C6,$FE,$00,$00,$00,$00    ' -2-
ASCII_0816_051 byte        $00,$00,$7C,$C6,$06,$06,$3C,$06,$06,$06,$C6,$7C,$00,$00,$00,$00    ' -3-
ASCII_0816_052 byte        $00,$00,$0C,$1C,$3C,$6C,$CC,$FE,$0C,$0C,$0C,$1E,$00,$00,$00,$00    ' -4-
ASCII_0816_053 byte        $00,$00,$FE,$C0,$C0,$C0,$FC,$0E,$06,$06,$C6,$7C,$00,$00,$00,$00    ' -5-
ASCII_0816_054 byte        $00,$00,$38,$60,$C0,$C0,$FC,$C6,$C6,$C6,$C6,$7C,$00,$00,$00,$00    ' -6-
ASCII_0816_055 byte        $00,$00,$FE,$C6,$06,$06,$0C,$18,$30,$30,$30,$30,$00,$00,$00,$00    ' -7-
ASCII_0816_056 byte        $00,$00,$7C,$C6,$C6,$C6,$7C,$C6,$C6,$C6,$C6,$7C,$00,$00,$00,$00    ' -8-
ASCII_0816_057 byte        $00,$00,$7C,$C6,$C6,$C6,$7E,$06,$06,$06,$0C,$78,$00,$00,$00,$00    ' -9-
ASCII_0816_058 byte        $00,$00,$00,$00,$18,$18,$00,$00,$00,$18,$18,$00,$00,$00,$00,$00    ' -:-
ASCII_0816_059 byte        $00,$00,$00,$00,$18,$18,$00,$00,$00,$18,$18,$30,$00,$00,$00,$00    ' -;-
ASCII_0816_060 byte        $00,$00,$00,$06,$0C,$18,$30,$60,$30,$18,$0C,$06,$00,$00,$00,$00    ' -<-
ASCII_0816_061 byte        $00,$00,$00,$00,$00,$00,$FE,$00,$00,$FE,$00,$00,$00,$00,$00,$00    ' -=-
ASCII_0816_062 byte        $00,$00,$00,$60,$30,$18,$0C,$06,$0C,$18,$30,$60,$00,$00,$00,$00    ' ->-
ASCII_0816_063 byte        $00,$00,$7C,$C6,$C6,$0C,$18,$18,$18,$00,$18,$18,$00,$00,$00,$00    ' -?-
ASCII_0816_064 byte        $00,$00,$00,$7C,$C6,$C6,$DE,$DE,$DE,$DC,$C0,$7C,$00,$00,$00,$00    ' -@-
ASCII_0816_065 byte        $00,$00,$10,$38,$6C,$C6,$C6,$FE,$C6,$C6,$C6,$C6,$00,$00,$00,$00    ' -A-
ASCII_0816_066 byte        $00,$00,$FC,$66,$66,$66,$7C,$66,$66,$66,$66,$FC,$00,$00,$00,$00    ' -B-
ASCII_0816_067 byte        $00,$00,$3C,$66,$C2,$C0,$C0,$C0,$C0,$C2,$66,$3C,$00,$00,$00,$00    ' -C-
ASCII_0816_068 byte        $00,$00,$F8,$6C,$66,$66,$66,$66,$66,$66,$6C,$F8,$00,$00,$00,$00    ' -D-
ASCII_0816_069 byte        $00,$00,$FE,$66,$62,$68,$78,$68,$60,$62,$66,$FE,$00,$00,$00,$00    ' -E-
ASCII_0816_070 byte        $00,$00,$FE,$66,$62,$68,$78,$68,$60,$60,$60,$F0,$00,$00,$00,$00    ' -F-
ASCII_0816_071 byte        $00,$00,$3C,$66,$C2,$C0,$C0,$DE,$C6,$C6,$66,$3A,$00,$00,$00,$00    ' -G-
ASCII_0816_072 byte        $00,$00,$C6,$C6,$C6,$C6,$FE,$C6,$C6,$C6,$C6,$C6,$00,$00,$00,$00    ' -H-
ASCII_0816_073 byte        $00,$00,$3C,$18,$18,$18,$18,$18,$18,$18,$18,$3C,$00,$00,$00,$00    ' -I-
ASCII_0816_074 byte        $00,$00,$1E,$0C,$0C,$0C,$0C,$0C,$CC,$CC,$CC,$78,$00,$00,$00,$00    ' -J-
ASCII_0816_075 byte        $00,$00,$E6,$66,$6C,$6C,$78,$78,$6C,$66,$66,$E6,$00,$00,$00,$00    ' -K-
ASCII_0816_076 byte        $00,$00,$F0,$60,$60,$60,$60,$60,$60,$62,$66,$FE,$00,$00,$00,$00    ' -L-
ASCII_0816_077 byte        $00,$00,$C6,$EE,$FE,$FE,$D6,$C6,$C6,$C6,$C6,$C6,$00,$00,$00,$00    ' -M-
ASCII_0816_078 byte        $00,$00,$C6,$E6,$F6,$FE,$DE,$CE,$C6,$C6,$C6,$C6,$00,$00,$00,$00    ' -N-
ASCII_0816_079 byte        $00,$00,$38,$6C,$C6,$C6,$C6,$C6,$C6,$C6,$6C,$38,$00,$00,$00,$00    ' -O-
ASCII_0816_080 byte        $00,$00,$FC,$66,$66,$66,$7C,$60,$60,$60,$60,$F0,$00,$00,$00,$00    ' -P-
ASCII_0816_081 byte        $00,$00,$7C,$C6,$C6,$C6,$C6,$C6,$C6,$D6,$DE,$7C,$0C,$0E,$00,$00    ' -Q-
ASCII_0816_082 byte        $00,$00,$FC,$66,$66,$66,$7C,$6C,$66,$66,$66,$E6,$00,$00,$00,$00    ' -R-
ASCII_0816_083 byte        $00,$00,$7C,$C6,$C6,$60,$38,$0C,$06,$C6,$C6,$7C,$00,$00,$00,$00    ' -S-
ASCII_0816_084 byte        $00,$00,$7E,$7E,$5A,$18,$18,$18,$18,$18,$18,$3C,$00,$00,$00,$00    ' -T-
ASCII_0816_085 byte        $00,$00,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$7C,$00,$00,$00,$00    ' -U-
ASCII_0816_086 byte        $00,$00,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$6C,$38,$10,$00,$00,$00,$00    ' -V-
ASCII_0816_087 byte        $00,$00,$C6,$C6,$C6,$C6,$C6,$D6,$D6,$FE,$6C,$6C,$00,$00,$00,$00    ' -W-
ASCII_0816_088 byte        $00,$00,$C6,$C6,$6C,$6C,$38,$38,$6C,$6C,$C6,$C6,$00,$00,$00,$00    ' -X-
ASCII_0816_089 byte        $00,$00,$66,$66,$66,$66,$3C,$18,$18,$18,$18,$3C,$00,$00,$00,$00    ' -Y-
ASCII_0816_090 byte        $00,$00,$FE,$C6,$86,$0C,$18,$30,$60,$C2,$C6,$FE,$00,$00,$00,$00    ' -Z-                                                                          
ASCII_0816_091 byte        $00,$00,$3C,$30,$30,$30,$30,$30,$30,$30,$30,$3C,$00,$00,$00,$00    ' -[-
ASCII_0816_092 byte        $00,$00,$00,$80,$C0,$E0,$70,$38,$1C,$0E,$06,$02,$00,$00,$00,$00    ' -\-
ASCII_0816_093 byte        $00,$00,$3C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$3C,$00,$00,$00,$00    ' -]-
ASCII_0816_094 byte        $10,$38,$6C,$C6,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00    ' -^-
ASCII_0816_095 byte        $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$00,$00    ' -_-
ASCII_0816_096 byte        $30,$30,$18,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00    ' -`-
ASCII_0816_097 byte        $00,$00,$00,$00,$00,$78,$0C,$7C,$CC,$CC,$CC,$76,$00,$00,$00,$00    ' -a-
ASCII_0816_098 byte        $00,$00,$E0,$60,$60,$78,$6C,$66,$66,$66,$66,$DC,$00,$00,$00,$00    ' -b-
ASCII_0816_099 byte        $00,$00,$00,$00,$00,$7C,$C6,$C0,$C0,$C0,$C6,$7C,$00,$00,$00,$00    ' -c-
ASCII_0816_100 byte        $00,$00,$1C,$0C,$0C,$3C,$6C,$CC,$CC,$CC,$CC,$76,$00,$00,$00,$00    ' -d-
ASCII_0816_101 byte        $00,$00,$00,$00,$00,$7C,$C6,$FE,$C0,$C0,$C6,$7C,$00,$00,$00,$00    ' -e-
ASCII_0816_102 byte        $00,$00,$38,$6C,$64,$60,$F0,$60,$60,$60,$60,$F0,$00,$00,$00,$00    ' -f-
ASCII_0816_103 byte        $00,$00,$00,$00,$00,$76,$CC,$CC,$CC,$CC,$CC,$7C,$0C,$CC,$78,$00    ' -g-
ASCII_0816_104 byte        $00,$00,$E0,$60,$60,$6C,$76,$66,$66,$66,$66,$E6,$00,$00,$00,$00    ' -h-
ASCII_0816_105 byte        $00,$00,$18,$18,$00,$38,$18,$18,$18,$18,$18,$3C,$00,$00,$00,$00    ' -i-
ASCII_0816_106 byte        $00,$00,$06,$06,$00,$0E,$06,$06,$06,$06,$06,$06,$66,$66,$3C,$00    ' -j-
ASCII_0816_107 byte        $00,$00,$E0,$60,$60,$66,$6C,$78,$78,$6C,$66,$E6,$00,$00,$00,$00    ' -k-
ASCII_0816_108 byte        $00,$00,$38,$18,$18,$18,$18,$18,$18,$18,$18,$3C,$00,$00,$00,$00    ' -l-
ASCII_0816_109 byte        $00,$00,$00,$00,$00,$EC,$FE,$D6,$D6,$D6,$D6,$D6,$00,$00,$00,$00    ' -m-
ASCII_0816_110 byte        $00,$00,$00,$00,$00,$DC,$66,$66,$66,$66,$66,$66,$00,$00,$00,$00    ' -n-
ASCII_0816_111 byte        $00,$00,$00,$00,$00,$7C,$C6,$C6,$C6,$C6,$C6,$7C,$00,$00,$00,$00    ' -o-
ASCII_0816_112 byte        $00,$00,$00,$00,$00,$DC,$66,$66,$66,$66,$66,$7C,$60,$60,$F0,$00    ' -p-
ASCII_0816_113 byte        $00,$00,$00,$00,$00,$76,$CC,$CC,$CC,$CC,$CC,$7C,$0C,$0C,$1E,$00    ' -q-
ASCII_0816_114 byte        $00,$00,$00,$00,$00,$DC,$76,$62,$60,$60,$60,$F0,$00,$00,$00,$00    ' -r-
ASCII_0816_115 byte        $00,$00,$00,$00,$00,$7C,$C6,$60,$38,$0C,$C6,$7C,$00,$00,$00,$00    ' -s-
ASCII_0816_116 byte        $00,$00,$10,$30,$30,$FC,$30,$30,$30,$30,$36,$1C,$00,$00,$00,$00    ' -t-
ASCII_0816_117 byte        $00,$00,$00,$00,$00,$CC,$CC,$CC,$CC,$CC,$CC,$76,$00,$00,$00,$00    ' -u-
ASCII_0816_118 byte        $00,$00,$00,$00,$00,$66,$66,$66,$66,$66,$3C,$18,$00,$00,$00,$00    ' -v-
ASCII_0816_119 byte        $00,$00,$00,$00,$00,$C6,$C6,$C6,$D6,$D6,$FE,$6C,$00,$00,$00,$00    ' -w-
ASCII_0816_120 byte        $00,$00,$00,$00,$00,$C6,$6C,$38,$38,$38,$6C,$C6,$00,$00,$00,$00    ' -x-
ASCII_0816_121 byte        $00,$00,$00,$00,$00,$C6,$C6,$C6,$C6,$C6,$C6,$7E,$06,$0C,$F8,$00    ' -y-
ASCII_0816_122 byte        $00,$00,$00,$00,$00,$FE,$CC,$18,$30,$60,$C6,$FE,$00,$00,$00,$00    ' -z-
ASCII_0816_123 byte        $00,$00,$0E,$18,$18,$18,$70,$18,$18,$18,$18,$0E,$00,$00,$00,$00    ' -{-
ASCII_0816_124 byte        $00,$00,$18,$18,$18,$18,$00,$18,$18,$18,$18,$18,$00,$00,$00,$00    ' -|-
ASCII_0816_125 byte        $00,$00,$70,$18,$18,$18,$0E,$18,$18,$18,$18,$70,$00,$00,$00,$00    ' -}-
ASCII_0816_126 byte        $00,$00,$76,$DC,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00    ' -~-
ASCII_0816_127 byte        $00,$00,$00,$00,$10,$38,$6C,$C6,$C6,$C6,$FE,$00,$00,$00,$00,$00    ' --
}
'' Eyes patterns for robot's right eye (on viewer's left). The left eyes should be a mirror image
'' of the right.
'' The first six eye patterns are taken from Dickel's work on Let's Make Robots node 37367.
DAT eyeNormal           byte %01111100
                        byte %11111110
                        byte %11000110
                        byte %11000110
                        byte %11111110
                        byte %01111100
                        byte %00000000
                        byte %00000000
                        
eyeSad                  byte %11111110
                        byte %11111110
                        byte %11000110
                        byte %01111100
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        
eyeSurprise             byte %00111000           
                        byte %01111100
                        byte %11000110
                        byte %11000110
                        byte %11000110
                        byte %11000110
                        byte %01111100
                        byte %00111000           
                        
eyeHappy                byte %00111000
                        byte %01111100
                        byte %11111110
                        byte %11000110
                        byte %11000110
                        byte %11111110
                        byte %01111100
                        byte %00000000

eyeFear                 byte %01111100
                        byte %11111110
                        byte %11000110
                        byte %11000110
                        byte %11000110
                        byte %01111100
                        byte %00000000
                        byte %00000000
                        
eyeCrossed              byte %00111100
                        byte %01111110
                        byte %11100110
                        byte %11100110
                        byte %11100110
                        byte %01111110
                        byte %00111100
                        byte %00000000

eyeOvalVert             byte %00111000
                        byte %01111100
                        byte %11111110
                        byte %11000110
                        byte %11000110
                        byte %11111110
                        byte %01111100
                        byte %00111000

eyeOvalHor              byte %00111100
                        byte %01111110
                        byte %11100111
                        byte %11100111
                        byte %11100111
                        byte %01111110
                        byte %00111100
                        byte %00000000
                        
eyeSlitVert0            byte %00110000
                        byte %01111000
                        byte %11111100
                        byte %11001100
                        byte %11001100
                        byte %11111100
                        byte %01111000
                        byte %00110000

eyeSlitVert1            byte %00100000
                        byte %01110000
                        byte %11111000
                        byte %11011000
                        byte %11011000
                        byte %11111000
                        byte %01110000
                        byte %00100000

eyeSlitHor0             byte %00111100
                        byte %01111110
                        byte %11100111
                        byte %11100111
                        byte %01111110
                        byte %00111100
                        byte %00000000
                        byte %00000000
                        
eyeSlitHor1             byte %00111100
                        byte %01111110
                        byte %11100111
                        byte %01111110
                        byte %00111100
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        
DAT '' Eye Masks
mskNormal               byte %01111100
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %01111100
                        byte %00000000
                        byte %00000000
                        
mskSad                  byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %01111100
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        byte %00000000
                        
mskSurprise             byte %00111000           
                        byte %01111100
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %01111100
                        byte %00111000           
                        
mskHappy                byte %00111000
                        byte %01111100
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %01111100
                        byte %00000000

mskFear                 byte %01111100
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %01111100
                        byte %00000000
                        byte %00000000
                        
mskCrossed              byte %00111100
                        byte %01111110
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %01111110
                        byte %00111100
                        byte %00000000

mskOvalVert             byte %00111000
                        byte %01111100
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %11111110
                        byte %01111100
                        byte %00111000

mskOvalHor              byte %00111100
                        byte %01111110
                        byte %11111111
                        byte %11111111
                        byte %11111111
                        byte %01111110
                        byte %00111100
                        byte %00000000
                        
mskSlitVert0            byte %00110000
                        byte %01111000
                        byte %11111100
                        byte %11111100
                        byte %11111100
                        byte %11111100
                        byte %01111000
                        byte %00110000

mskSlitVert1            byte %00100000
                        byte %01110000
                        byte %11111000
                        byte %11111000
                        byte %11111000
                        byte %11111000
                        byte %01110000
                        byte %00100000

mskSlitHor0             byte %00111100
                        byte %01111110
                        byte %11111111
                        byte %11111111
                        byte %01111110
                        byte %00111100
                        byte %00000000
                        byte %00000000
                        
mskSlitHor1             byte %00111100
                        byte %01111110
                        byte %11111111
                        byte %01111110
                        byte %00111100
                        byte %00000000
                        byte %00000000
                        byte %00000000

eyeCharacter            byte "@", ")", "!", "(", "#", "^", "{", "}", "|", "[", "_", "]", 0                        
eyeAlignFromOuter       byte 0[5], 1, 0, 1, 2, 0[2]
eyeAlignFromTop         byte 1, 2, 0, 0, 1, 0[5], 1, 1
eyePupilTop             byte 0[EYE_SLIT_HOR1 + 1]
eyePupilBottom          byte 0[EYE_SLIT_HOR1 + 1] 
eyePupilOuter           byte 0[EYE_SLIT_HOR1 + 1]    
eyePupilInner           byte 0[EYE_SLIT_HOR1 + 1]
eyeWidth                byte 0[EYE_SLIT_HOR1 + 1]
eyeHeight               byte 0[EYE_SLIT_HOR1 + 1]
                                                                                                                                                  
DAT 'speed to delay lookup table

speedToDelay            long 2000, 1951, 1904, 1857, 1811, 1765, 1721, 1677, 1635, 1593
                        long 1551, 1511, 1471, 1432, 1394, 1357, 1320, 1284, 1249, 1214
                        long 1180, 1147, 1115, 1083, 1051, 1021, 991, 961, 933, 904
                        long 877, 850, 824, 798, 772, 748, 723, 700, 677, 654
                        long 632, 610, 589, 569, 549, 529, 510, 491, 473, 455
                        long 438, 421, 404, 388, 373, 358, 343, 328, 314, 301
                        long 287, 275, 262, 250, 238, 227, 216, 205, 194, 184
                        long 175, 165, 156, 147, 139, 131, 123, 115, 108, 101
                        long 94, 88, 82, 76, 70, 65, 59, 55, 50, 46
                        long 41, 37, 34, 30, 27, 24, 21, 18, 16, 14
extraJustIncase         long 12, 10, 8, 6, 4, 3, 2, 1, 0
' try to make 16 x 8 patterns
'      ggyyoorrvviibbgg
'      gyyoorrvviibbggy
'      yyoorrvviibbggyy
'      yoorrvviibbggyyo
'      oorrvviibbggyyoo
'      orrvviibbggyyoor
'      rrvviibbggyyoorr
'      rvviibbggyyoorrv                           
DAT

testBuffer0             byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
{diagonal rainbow}      byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        
DAT fontSpace           byte 0[EYES_BYTES] '[FONT_BYTES_IN_EEPROM]
scratchSpace            byte 0[FONT_BYTES_IN_EEPROM] ' some empty bytes for between character space

testBuffer2             byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
{diagonal rainbow}      byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, RED_R, RED_G, RED_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte INDIGO_R, INDIGO_G, INDIGO_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte RED_R, RED_G, RED_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, INDIGO_R, INDIGO_G, INDIGO_B
                        byte INDIGO_R, INDIGO_G, INDIGO_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, GREEN_R, GREEN_G, GREEN_B

' try to make 16 x 8 patterns
'      rrooyyggggyyoorr
'      rooyyggbbggyyoor
'      ooyyggbbbbggyyoo
'      oyyggbbvvbbggyyo
'      oyyggbbvvbbggyyo
'      ooyyggbbbbggyyoo
'      rooyyggbbggyyoor
'      rrooyyggggyyoorr
' graphColumn starting at bottom of column
graphColumn             byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
DAT patternD00          byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B


                        
patternD01              byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B
                        

patternD02              byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        


patternD03              byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B


patternD04              byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        

patternD05              byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        
                        {byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B
                        }
                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        byte YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B


patternD06              byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        
                        


patternD07              byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        
                        byte GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B

                        
                        
patternD08              byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        

                        
patternD09              byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        byte BLUE_R, BLUE_G, BLUE_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte BLUE_R, BLUE_G, BLUE_B

                        
patternD10              byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B, VIOLET_R, VIOLET_G, VIOLET_B
                        
                        
patternD11              byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B

                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte BLUE_R, BLUE_G, BLUE_B, BLUE_R, BLUE_G, BLUE_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte GREEN_R, GREEN_G, GREEN_B, GREEN_R, GREEN_G, GREEN_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte VIOLET_R, VIOLET_G, VIOLET_B
                      

DAT messageBuffer       byte "Parallax Propeller driving 8X8 RGB LED array. LEDs are fun!   ",0[LARGEST_TEXT_MESSAGE - 61]
                             '1234567890123456789012345678901234567890123456789012345678901
    
DAT resizedPattern      byte 0[MAX_ALLOWED_DISPLAY_BYTES]
{patternS01              byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B

                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B
                        byte RED_R, RED_G, RED_B, RED_R, RED_G, RED_B


patternS02              byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        byte ORANGE_R, ORANGE_G, ORANGE_B, ORANGE_R, ORANGE_G, ORANGE_B
                        
patternS03              byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B

                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B
                        byte YELLOW_R, YELLOW_G, YELLOW_B, YELLOW_R, YELLOW_G, YELLOW_B    }
                             '         1         2         3         4         5         6
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT messageBuffer0      byte SF, SIMPLYTRONICS_0508, SD, 100, SB, 64, SFC, WHITE, "Comparing 8x8 ", SFC, RED, "R" 
                        byte SFC, GREEN, "G", SFC, BLUE, "B", SFC, WHITE
                        byte " LED arrays. The 60mm array is from eBay. The "
                        byte " 38mm array is made by SimplyTronics. "
                        byte "This font 5x8 font comes with the SimplyTronics array. "
                        byte SF, FREE_DESIGN
                        byte " Free Design is a dot matrix font I found on the internet."
                        byte " I ", SD, 80, "think this font ", SD, 60
                        byte "is easier to read ", SD, 60, "when the text is "
                        byte "scrolling fast. "
                        'byte SFC, GREEN," (Sp", SD, 80, "eeding", SD, 60, " up ", SD, 40
                        'byte "scrolling) "
                        byte SFC, RED, "Besides ", SFC, ORANGE, SBC, BLUE, "the "
                        byte SFC, YELLOW, SBC, GREEN, "size "
                        byte SFC, GREEN, SBC, YELLOW, "difference, ", SFC, CYAN, SBC, RED
                        byte "the ", SFC, BLUE, SBC, ORANGE, "larger "
                        byte SFC, VIOLET, SBC, BLACK, "array is much brighter. ", SFC, WHITE
                        byte "The current brightness "
                        byte "level of the ", SFC, RED, "L", SFC, WHITE
                        byte "arge array is 64 of 255.  The ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall array is 255 or 255.   Turning the brightness of "
                        byte "both units down. ", SB, 56, SBST, 223, SFC, RED, "L", SFC, WHITE
                        byte "arge brightness is now 56. ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall brightness is now 223. "
                        byte SB, 48, SBST, 191, SFC, RED, "L", SFC, WHITE
                        byte "arge 48, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 191. "
                        byte SB, 40, SBST, 159, SFC, RED, "L", SFC, WHITE
                        byte "arge 40, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 159. " 
                        byte SB, 32, SBST, 127, SFC, RED, "L", SFC, WHITE
                        byte "arge 32, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 127. " 
                        byte SB, 24, SBST, 95, SFC, RED, "L", SFC, WHITE
                        byte "arge 24, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 95. " 
                        byte SB, 16, SBST, 63, SFC, RED, "L", SFC, WHITE
                        byte "arge 16, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 63. " 
                        byte SB, 8, SBST, 31, SFC, RED, "L", SFC, WHITE
                        byte "arge 8, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 31. "
                        byte SB, 24, SBST, 95, "Turning ", SB, 32, SBST, 127
                        byte "the ", SB, 40, SBST, 159, "brightness", SB, 48, SBST, 191
                        byte " back ", SB, 56, SBST, 223, "to where we ", SB, 64, SBST, 255, "started. "
                        byte SFC, RED, "L", SFC, WHITE
                        byte "arge 64, ", SFC, BLUE, "S"
                        byte SFC, WHITE, "mall 255. "
                        byte "The ", SB, 72, "lar", SB, 80, "ge ", SB, 88, "scr"
                        byte SB, 96, "een ", SB, 104, "can ", SB, 112, "get "
                        byte SB, 120, "even ", SB, 128, "bri", SB, 136, "ghter. ", SB, 144  
                        byte "And ", SB, 152, "bri", SB, 160, "ghter "
                        byte SB, 168, "sti", SB, 176, "ll. ", SB, 184 
                        byte "All ", SB, 192, "the ", SB, 200, "way ", SB, 208  
                        byte "up ", SB, 216, "to ", SB, 224, "its ", SB, 232
                        byte "bri", SB, 240, "ght", SB, 248, "est ", SB, 255
                        byte "level of 255."  
                        
                        
                             '1234567890123456789012345678901234567890123456789012345678901     
DAT messageBuffer1      byte 0[32]
                             '1234567890123456789012345678901234567890123456789012345678901     
'DAT messageBuffer       byte "Parallax Propeller driving 8X8 RGB LED array. LEDs are fun!   ",0[LARGEST_TEXT_MESSAGE - 61]
DAT end                 byte $AA[$100]                                                    